// IOCntrl.h: interface for the CIOCntrl class.
//
//////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_IOCNTRL_H__ED8BF853_5C8C_11D3_A248_00A0C996E7F5__INCLUDED_)
#define AFX_IOCNTRL_H__ED8BF853_5C8C_11D3_A248_00A0C996E7F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PskDet.h"
#include "Sound.h"
#include "PSKMod.h"
#include "PskDet.h"


class CIOCntrl  
{
public:
	void StartIO(CWinPSKDoc* pDoc );
	void StopIO();
	void ProcessLoop();
	CIOCntrl();
	virtual ~CIOCntrl();

private:
	void InitDec2Filter();
	void PTTCntrl( BOOL Ptton );
	void ProcessRcv();
	void ProcessXmit();
	void DeleteResources();
	void StopThread( );
	void ProcDec2FIR( double* pIn, double* pOut , INT BlockSize);
	void DisplayError( INT ErrorCode );
	void AddGaussian(double * pData, INT n, double std);

	CWinThread *m_pProcThread;
	CWinPSKDoc* m_pDoc;
	BOOL m_fProcThreadQuit;			// signal to thread to quit
	double* m_pIOBuf;
	double* m_pDispBuf;
	_complex* m_pCpxBuf;

	CString m_ErrMsg;
	UINT m_ErrorCode;

	double* m_pDec2InPtr;		//Decimate by 2 pointers
	double* m_pDec2Que;
	CPskDet* m_pPskDet;

	CSound* m_pSoundDev;			//object pointers
	CPSKMod* m_pPSKMod;

	HANDLE m_hComPort;
};

#endif // !defined(AFX_IOCNTRL_H__ED8BF853_5C8C_11D3_A248_00A0C996E7F5__INCLUDED_)
