// MainFrm.cpp : implementation of the CMainFrame class
//
//
#include "stdafx.h"
#include "WinPSK.h"
#include "WinPSKDoc.h"
#include "RcvView.h"
#include "XmitView.h"
#include "SetDlg.h"
#include "DemoDlg.h"
#include "WinPSKView.h"
#include "Perform.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define NORM_SAMPLEPERIOD 371519L	//(1/11025) * 4096 * 1e6 = Main buffer period in uSeconds
#define FAST_SAMPLEPERIOD 20000L	//
/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_INITMENUPOPUP()
	ON_WM_MENUSELECT()
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_TIME, OnUpdateTime)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDM_RCVBACKCOLOR, OnRcvbackcolor)
	ON_COMMAND(IDM_XMITBACKCOLOR, OnXmitbackcolor)
	ON_COMMAND(IDM_RCVFONT, OnRcvfont)
	ON_COMMAND(IDM_XMITFONT, OnXmitfont)
	ON_COMMAND(IDM_XMITSENTFONT, OnXmitsentfont)
	ON_WM_CLOSE()
	ON_COMMAND(IDM_CLEARRCV, OnClearrcv)
	ON_COMMAND(IDM_CLEARXMIT, OnClearxmit)
	ON_COMMAND(ID_SETUP, OnSetup)
	ON_COMMAND(IDM_DEMODLG, OnDemomode)
	ON_COMMAND(ID_RXLVLSETUP, OnRxlvlsetup)
	ON_COMMAND(ID_TXLVLSETUP, OnTxlvlsetup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	IDS_STATUSBAR1,
	IDS_STATUSBAR2,
	IDS_STATUSBAR3,
	IDS_STATUSBAR4
//	ID_SEPARATOR,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_nStatusPane1Width = -1;
	m_bMenuSelect = FALSE;
	m_wp.length = 0;
}

CMainFrame::~CMainFrame()
{
}

///////////////////////////////////////////////////////////////
// create the outer frame stuff
///////////////////////////////////////////////////////////////
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
//create status and toolbar	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD /*| WS_VISIBLE*/ | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	//  Delete these three lines if you don't want the toolbar to
	//  be dockable
//	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
//	EnableDocking(CBRS_ALIGN_ANY);
//	DockControlBar(&m_wndToolBar);

	CWinPSKView* pWnd = (CWinPSKView*)m_WndSplitter.GetPane(2,0);
	ASSERT_VALID( pWnd );
	CSize size = pWnd->GetTotalSize();	//get size of window
	m_wp.length = sizeof(WINDOWPLACEMENT);
// get screen size settings if they are saved in registry
	if( LoadWindowPlacement(&m_wp, &m_Pane0Height, &m_Pane1Height, &m_Pane2Height))
	{
		m_WndSplitter.SetRowInfo(0,m_Pane0Height,10);
		m_WndSplitter.SetRowInfo(1,m_Pane1Height,10);
		m_WndSplitter.SetRowInfo(2,m_Pane2Height,10);
	}
	else
	{
		// set defauult splitter sizes if none are loaded from the registry
		CRect rc;
		GetClientRect( rc );
		m_WndSplitter.SetRowInfo(2,size.cy,10);
		m_WndSplitter.SetRowInfo(0,(rc.bottom-size.cy)/2,10);
		m_WndSplitter.SetRowInfo(1,(rc.bottom-size.cy)/3,10);
		m_wp.length = 0;
	}
	m_WndSplitter.SetColumnInfo(0,size.cx,10);
	LoadBarState("ControlBars\\State");	//restore status/toolbar states
	SetActiveView( pWnd, TRUE);
	// Find out the size of the static variable 'indicators' defined
	// by AppWizard and copy it
	int nOrigSize = sizeof(indicators) / sizeof(UINT);
	UINT* pIndicators = new UINT[nOrigSize + 1];
	memcpy(pIndicators, indicators, sizeof(indicators));
	// Call the Status Bar Component's status bar creation function
	m_nTimePaneNo = nOrigSize;
	pIndicators[m_nTimePaneNo] = ID_INDICATOR_TIME;
	if( !m_wndStatusBar.SetIndicators(pIndicators, m_nTimePaneNo+1) )
	{
		TRACE0("Failed to initialize Status Bar\n");
		return -1;
	}
	delete[] pIndicators;
	return 0;
}


///////////////////////////////////////////////////////////////
// create splitter views
///////////////////////////////////////////////////////////////
BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	VERIFY(m_WndSplitter.CreateStatic( this,3,1));		//3 rows, 1 column
	VERIFY(m_WndSplitter.CreateView(0,0,
			RUNTIME_CLASS(CRcvView),CSize(0,0), pContext));
	
	VERIFY(m_WndSplitter.CreateView(1,0,
			RUNTIME_CLASS(CXmitView),CSize(0,0), pContext));
	
	VERIFY(m_WndSplitter.CreateView(2,0,
			RUNTIME_CLASS(CWinPSKView),CSize(0,0), pContext));
	return TRUE;
}

///////////////////////////////////////////////////////////////
// get registry screen size settings
///////////////////////////////////////////////////////////////
BOOL CMainFrame::LoadWindowPlacement(LPWINDOWPLACEMENT pwp, INT* P0Height, INT* P1Height, INT* P2Height)
{
	CString strBuffer = AfxGetApp ()->GetProfileString ("Settings", "WindowPos");
	if (strBuffer.IsEmpty ())
		return FALSE;
	int cRead = _stscanf (strBuffer, "%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:%i",
			&pwp->flags, &pwp->showCmd,
			&pwp->ptMinPosition.x, &pwp->ptMinPosition.y,
			&pwp->ptMaxPosition.x, &pwp->ptMaxPosition.y,
			&pwp->rcNormalPosition.left, &pwp->rcNormalPosition.top,
			&pwp->rcNormalPosition.right, &pwp->rcNormalPosition.bottom,
			P0Height, P1Height, P2Height);

	if (cRead != 13)
		return FALSE;
	return TRUE;

}

///////////////////////////////////////////////////////////////
// save screen size settings to registry
///////////////////////////////////////////////////////////////
void CMainFrame::SaveWindowPlacement(LPWINDOWPLACEMENT pwp, INT P0Height, INT P1Height, INT P2Height)
{
	// SaveWindowPlacement
	CString strBuffer;
	strBuffer.Format ("%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:%i",
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom,
		P0Height, P1Height, P2Height);

	AfxGetApp()->WriteProfileString("Settings", "WindowPos", strBuffer);
}

///////////////////////////////////////////////////////////////
// keep default title off the top system bar
///////////////////////////////////////////////////////////////
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style &= ~FWS_ADDTOTITLE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers for menu commands/actions

void CMainFrame::OnClearrcv() 
{
	CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
	pDoc->m_pRcvEdit->ClearAll();
}

///////////////////////////////////////////////////////////////
void CMainFrame::OnClearxmit() 
{
	CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
	pDoc->m_pXmitEdit->ClearAll();
	pDoc->m_StopAfterText = FALSE;
	pDoc->m_NeedCWid = FALSE;
}
///////////////////////////////////////////////////////////////
void CMainFrame::OnRcvbackcolor() 
{
CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
	CColorDialog dlgColor(pDoc->m_pSettings->m_crRcvBackColor, CC_RGBINIT);
	if (dlgColor.DoModal() == IDOK)
	{
		pDoc->m_pSettings->m_crRcvBackColor = dlgColor.GetColor();
		pDoc->m_pRcvEdit->SetBackgroundColor( FALSE, pDoc->m_pSettings->m_crRcvBackColor );
	}
}
///////////////////////////////////////////////////////////////
void CMainFrame::OnRcvfont() 
{
CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
	CClientDC dc(NULL);
	LOGFONT lf = pDoc->m_pSettings->m_lfRcvFont;
	lf.lfHeight = -::MulDiv(-lf.lfHeight, dc.GetDeviceCaps(LOGPIXELSY), 72);
	CFontDialog dlg(&lf);
	dlg.m_cf.rgbColors = pDoc->m_pSettings->m_crRcvTextColor;
	if (dlg.DoModal() == IDOK)
	{
		pDoc->m_pSettings->m_crRcvTextColor = dlg.GetColor();
		lf.lfHeight = -::MulDiv(-lf.lfHeight, 72, dc.GetDeviceCaps(LOGPIXELSY));
		pDoc->m_pSettings->m_lfRcvFont = lf;
		pDoc->m_pRcvEdit->SetCharFormat(pDoc->m_pSettings->m_lfRcvFont,
			pDoc->m_pSettings->m_lfXmitFont,
			pDoc->m_pSettings->m_crRcvTextColor,
			pDoc->m_pSettings->m_crXmitSentTextColor,
			pDoc->m_pSettings->m_crRcvBackColor	);
	}
}

///////////////////////////////////////////////////////////////
void CMainFrame::OnXmitfont() 
{
CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
	CClientDC dc(NULL);
	LOGFONT lf = pDoc->m_pSettings->m_lfXmitFont;
	lf.lfHeight = -::MulDiv(-lf.lfHeight, dc.GetDeviceCaps(LOGPIXELSY), 72);
	CFontDialog dlg(&lf);
	dlg.m_cf.rgbColors = pDoc->m_pSettings->m_crXmitTextColor;
	if (dlg.DoModal() == IDOK)
	{
		lf.lfHeight = -::MulDiv(-lf.lfHeight, 72, dc.GetDeviceCaps(LOGPIXELSY));
		pDoc->m_pSettings->m_crXmitTextColor = dlg.GetColor();
		pDoc->m_pSettings->m_lfXmitFont = lf;
		pDoc->m_pXmitEdit->SetCharFormat(pDoc->m_pSettings->m_lfXmitFont,
			pDoc->m_pSettings->m_lfXmitSentFont,
			pDoc->m_pSettings->m_crXmitTextColor,
			pDoc->m_pSettings->m_crXmitSentTextColor,
			pDoc->m_pSettings->m_crXmitBackColor);
	}
}

///////////////////////////////////////////////////////////////
void CMainFrame::OnXmitsentfont() 
{
CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
	CClientDC dc(NULL);
	LOGFONT lf = pDoc->m_pSettings->m_lfXmitSentFont;
	lf.lfHeight = -::MulDiv(-lf.lfHeight, dc.GetDeviceCaps(LOGPIXELSY), 72);
	CFontDialog dlg(&lf);
	dlg.m_cf.rgbColors = pDoc->m_pSettings->m_crXmitSentTextColor;
	if (dlg.DoModal() == IDOK)
	{
		lf.lfHeight = -::MulDiv(-lf.lfHeight, 72, dc.GetDeviceCaps(LOGPIXELSY));
		pDoc->m_pSettings->m_crXmitSentTextColor = dlg.GetColor();
		pDoc->m_pSettings->m_lfXmitSentFont = lf;
		pDoc->m_pXmitEdit->SetCharFormat(pDoc->m_pSettings->m_lfXmitFont,
			pDoc->m_pSettings->m_lfXmitSentFont,
			pDoc->m_pSettings->m_crXmitTextColor,
			pDoc->m_pSettings->m_crXmitSentTextColor,
			pDoc->m_pSettings->m_crXmitBackColor);
		pDoc->m_pRcvEdit->SetCharFormat(pDoc->m_pSettings->m_lfRcvFont,
			pDoc->m_pSettings->m_lfXmitFont,
			pDoc->m_pSettings->m_crRcvTextColor,
			pDoc->m_pSettings->m_crXmitSentTextColor,
			pDoc->m_pSettings->m_crRcvBackColor	);
	}
	
}

///////////////////////////////////////////////////////////////
void CMainFrame::OnXmitbackcolor() 
{
	CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
	CColorDialog dlgColor(pDoc->m_pSettings->m_crXmitBackColor, CC_RGBINIT);
	if (dlgColor.DoModal() == IDOK)
	{
		pDoc->m_pSettings->m_crXmitBackColor = dlgColor.GetColor();
		pDoc->m_pXmitEdit->SetBackgroundColor( FALSE, pDoc->m_pSettings->m_crXmitBackColor );
	}
	
}

///////////////////////////////////////////////////////////////
// called during idle time to update the status bar
///////////////////////////////////////////////////////////////
void CMainFrame::UpdateStatus()
{
CString sBuf;
UINT nID, nStyle;
int nWidth, nIndex;
CSize szExtent;
INT cpuPercent;
	CClientDC dc(&m_wndStatusBar);
	CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
// Update status pane 1
	if( !pDoc->m_pSettings->m_DemoMode )
		switch( pDoc->m_TXState )
		{
			case TX_OFF_STATE:
				sBuf = _T(" Receiving ");
				break;
			case TX_PAUSED_STATE:
				sBuf = _T(" TX is Paused ");
				break;
			case TX_CWID_STATE:
				sBuf = _T(" Sending CW ID ");
				break;
			case TX_TUNE_STATE:
				sBuf = _T(" TX Tuning ");
				break;
			default:		// all other states are transmitting
				sBuf = _T("Transmitting ");
				break;
		}
	else
		switch( pDoc->m_TXState )
		{
			case TX_OFF_STATE:
				sBuf = _T(" Demo Mode Receiving ");
				break;
			case TX_PAUSED_STATE:
				sBuf = _T(" Demo Mode TX is Paused ");
				break;
			case TX_CWID_STATE:
				sBuf = _T(" Demo Mode Sending CW ID ");
				break;
			case TX_TUNE_STATE:
				sBuf = _T(" Demo Mode TX Tuning ");
				break;
			default:		// all other states are transmitting
				sBuf = _T(" Demo Mode Transmitting ");
				break;
		}

	nIndex = m_wndStatusBar.CommandToIndex(IDS_STATUSBAR1);
	CFont* pOldFont = dc.SelectObject(m_wndStatusBar.GetFont());
	szExtent = dc.GetTextExtent(sBuf, sBuf.GetLength() );
	m_wndStatusBar.GetPaneInfo(nIndex, nID, nStyle, nWidth);
	m_wndStatusBar.SetPaneInfo(nIndex, nID, nStyle, szExtent.cx);
	m_wndStatusBar.SetPaneText(nIndex, sBuf);


	if(pDoc->m_FastDemo)
		cpuPercent= ReadPerformance(FAST_SAMPLEPERIOD);
	else
		cpuPercent= ReadPerformance(NORM_SAMPLEPERIOD);
	if( cpuPercent > 100)
		cpuPercent= 100;
	sBuf = _T(" CPU = 100% ");
	nIndex = m_wndStatusBar.CommandToIndex(IDS_STATUSBAR2);
	szExtent = dc.GetTextExtent(sBuf, sBuf.GetLength() );
	sBuf.Format(" CPU = %d%% ", cpuPercent);
	m_wndStatusBar.GetPaneInfo(nIndex, nID, nStyle, nWidth);
	m_wndStatusBar.SetPaneInfo(nIndex, nID, nStyle, szExtent.cx);
	m_wndStatusBar.SetPaneText(nIndex, sBuf);

	
	sBuf = _T(" Clk ppm = -5000 ");
	nIndex = m_wndStatusBar.CommandToIndex(IDS_STATUSBAR3);
	szExtent = dc.GetTextExtent(sBuf, sBuf.GetLength() );
	sBuf.Format(" Clk ppm = %d ", (pDoc->m_ClkError/100)*100);
	m_wndStatusBar.GetPaneInfo(nIndex, nID, nStyle, nWidth);
	m_wndStatusBar.SetPaneInfo(nIndex, nID, nStyle, szExtent.cx);
	m_wndStatusBar.SetPaneText(nIndex, sBuf);

	dc.SelectObject(pOldFont);	//restore font
}

///////////////////////////////////////////////////////////////
// save stuff if closing program
///////////////////////////////////////////////////////////////
void CMainFrame::OnClose() 
{
INT x;
	KillTimer(m_TimerID);
	WINDOWPLACEMENT wp;
	wp.length = sizeof(WINDOWPLACEMENT);
	if (GetWindowPlacement(&wp) )
	{
		m_WndSplitter.GetRowInfo( 0, m_Pane0Height, x );
		m_WndSplitter.GetRowInfo( 1, m_Pane1Height, x );
		m_WndSplitter.GetRowInfo( 2, m_Pane2Height, x );
		if( IsZoomed() )
			wp.flags |= WPF_RESTORETOMAXIMIZED;

		SaveWindowPlacement( &wp, m_Pane0Height, m_Pane1Height, m_Pane2Height );
	}

	SaveBarState("ControlBars\\State");
	CFrameWnd::OnClose();
}

///////////////////////////////////////////////////////////////
void CMainFrame::OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu)
{
  	CFrameWnd::OnMenuSelect(nItemID, nFlags, hSysMenu);
  
	// CG: The following block was inserted by 'Status Bar' component.
	{
		// Restore first pane of the statusbar?
		if (nFlags == 0xFFFF && hSysMenu == 0 && m_nStatusPane1Width != -1)
		{
			m_bMenuSelect = FALSE;
			m_wndStatusBar.SetPaneInfo(0, 
				m_nStatusPane1ID, m_nStatusPane1Style, m_nStatusPane1Width);
			m_nStatusPane1Width = -1;   // Set it to illegal value
		}
		else 
		{
			m_bMenuSelect = TRUE;
		}
	}

}

///////////////////////////////////////////////////////////////
void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu)
{
  	CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
  
	// CG: The following block was inserted by 'Status Bar' component.
	{
		// store width of first pane and its style
		if (m_nStatusPane1Width == -1 && m_bMenuSelect)
		{
			m_wndStatusBar.GetPaneInfo(0, m_nStatusPane1ID, 
				m_nStatusPane1Style, m_nStatusPane1Width);
			m_wndStatusBar.SetPaneInfo(0, m_nStatusPane1ID, 
				SBPS_NOBORDERS|SBPS_STRETCH, 16384);
		}
	}

}

///////////////////////////////////////////////////////////////
void CMainFrame::OnUpdateTime(CCmdUI* pCmdUI)
{
	// Get current date and format it
CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
CTime time = CTime::GetCurrentTime();
CString strTime;
	if( pDoc->m_pSettings->m_UseLocalTime)
		strTime =    time.Format(_T(" %#d %b %Y     %#I:%M:%S %p "));
	else
		strTime = time.FormatGmt(_T(" %#d %b %Y     %#H:%M:%S UTC "));

	// compute the width of the date string
	CSize size;
	HGDIOBJ hOldFont = NULL;
	HFONT hFont = (HFONT)m_wndStatusBar.SendMessage(WM_GETFONT);
	CClientDC dc(NULL);
	if (hFont != NULL) 
		hOldFont = dc.SelectObject(hFont);
	size = dc.GetTextExtent(strTime);
	if (hOldFont != NULL) 
		dc.SelectObject(hOldFont);

	// Update the pane to reflect the current time
	UINT nID, nStyle;
	int nWidth;
	m_wndStatusBar.GetPaneInfo(m_nTimePaneNo, nID, nStyle, nWidth);
	m_wndStatusBar.SetPaneInfo(m_nTimePaneNo, nID, nStyle, size.cx);
	pCmdUI->SetText(strTime);
	pCmdUI->Enable(TRUE);

	UpdateStatus();		//go update program status stuff

}


///////////////////////////////////////////////////////////////
void CMainFrame::OnSetup() 
{
CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
CWinPSKView* pView = (CWinPSKView*)GetActiveView();
	ASSERT_VALID(pView);
CSetDlg dlg;
	dlg.m_sCallSign = pDoc->m_pSettings->m_sMyCall;
	dlg.m_UseSlash = pDoc->m_pSettings->m_UseSlash;
	dlg.m_PTTPort = pDoc->m_pSettings->m_PTTPort;
	dlg.m_ClockAdj = pDoc->m_pSettings->m_ClockAdj;
	dlg.m_UseLSB = pDoc->m_pSettings->m_UseLSB;
	dlg.m_UseMaxLikelyDet = pDoc->m_pSettings->m_UseMaxLikelyDet;
	dlg.m_UseLocalTime = pDoc->m_pSettings->m_UseLocalTime;
	dlg.m_EchoTXText = pDoc->m_pSettings->m_EchoTXText;

	if (dlg.DoModal() == IDOK)
	{
		pDoc->m_pSettings->m_sMyCall = dlg.m_sCallSign;
		pDoc->m_CWIdString = _T("de ") + dlg.m_sCallSign;

		CString str;
		str.LoadString(AFX_IDS_APP_TITLE);
		str = str + _T(" 1.2 - - ") + dlg.m_sCallSign;
		AfxGetMainWnd()->SetWindowText( str );
		pDoc->m_pSettings->m_UseSlash = dlg.m_UseSlash;
		pDoc->m_pRcvEdit->SetZeroCharDisplay(pDoc->m_pSettings->m_UseSlash);
		pDoc->m_pSettings->m_PTTPort = dlg.m_PTTPort;
		pDoc->m_pSettings->m_UseLSB = dlg.m_UseLSB;
		pDoc->m_pSettings->m_UseMaxLikelyDet = dlg.m_UseMaxLikelyDet;
		pDoc->m_pSettings->m_UseLocalTime = dlg.m_UseLocalTime;
		pDoc->m_pSettings->m_EchoTXText = dlg.m_EchoTXText;
		if(pDoc->m_pSettings->m_UseLSB)
			pView->m_QPSKCtrl.SetWindowText(_T("QPSK (lsb)"));
		else
			pView->m_QPSKCtrl.SetWindowText(_T("QPSK (usb)"));
		if( pDoc->m_pSettings->m_ClockAdj != dlg.m_ClockAdj )
		{	//start and stop process to make change affective
			pView->m_pIOCntrl->StopIO();
			pDoc->m_pSettings->m_ClockAdj = dlg.m_ClockAdj;
			pView->m_pIOCntrl->StartIO(pDoc);
		}

	}
}
////////////////////////////////////////////////////
//  Invoke Window's mixer control for Rx audio level adjustment
void CMainFrame::OnRxlvlsetup() 
{
	::WinExec(_T("SndVol32.exe /r"), SW_SHOW);	
}

////////////////////////////////////////////////////
//  Invoke Window's mixer control for Tx audio level adjustment
void CMainFrame::OnTxlvlsetup() 
{
	::WinExec(_T("SndVol32.exe /p"), SW_SHOW);	
}

///////////////////////////////////////////////////////////////
void CMainFrame::OnDemomode() 
{
CWinPSKDoc* pDoc = (CWinPSKDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
	CWinPSKView* pView = (CWinPSKView*)GetActiveView();
CDemoDlg dlg;
	pView->m_pIOCntrl->StopIO();
	dlg.m_SNR = (double)(pDoc->m_pSettings->m_SNR)/10.0;
	dlg.m_DemoMode = pDoc->m_pSettings->m_DemoMode;
	dlg.m_FastDemo = pDoc->m_FastDemo;
	if (dlg.DoModal() == IDOK)
	{
		pDoc->m_pSettings->m_SNR = (INT)(10.0*dlg.m_SNR);
		pDoc->m_pSettings->m_DemoMode = dlg.m_DemoMode;
		if(dlg.m_DemoMode)
			pDoc->m_FastDemo = dlg.m_FastDemo;
		else
			pDoc->m_FastDemo = FALSE;
		pDoc->Calc_SNR( pDoc->m_pSettings->m_SNR/10.0);
	}
	pView->m_pIOCntrl->StartIO(pDoc);

}

void CMainFrame::ActivateFrame(int nCmdShow) 
{
	if(	m_wp.length != 0)	//if structure has been filled in
	{
		nCmdShow= m_wp.showCmd;
		AfxGetApp ()->m_nCmdShow = nCmdShow;
		SetWindowPlacement(&m_wp);
	}
	else
		AfxGetApp ()->m_nCmdShow = nCmdShow;
	CFrameWnd::ActivateFrame(nCmdShow);
}

