//////////////////////////////////////////////////////////////////////
// PSKMod.h: interface for the CPSKMod class.
//
//////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_PSKMod_H__ACB4CEA2_C356_11D2_88B9_444553540000__INCLUDED_)
#define AFX_PSKMod_H__ACB4CEA2_C356_11D2_88B9_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000



#define TXOFF_CODE -1			// control codes that can be placed in the input
#define TXON_CODE -2			// queue for various control functions
#define TXTOG_CODE -3


#include "WinPSKDoc.h"


class CPSKMod  
{
public:
	CPSKMod();
	virtual ~CPSKMod();
// PSK31 and CW modulator
	void InitPSKMod(INT Fs, double freq, CWinPSKDoc* pDoc);
	void CalcPSK( double* pData , INT n);

private:
	CString m_TestString;
	INT m_AmblePtr;
	INT m_Preamble[33];
	INT m_Postamble[33];
	CWinPSKDoc* m_pDoc;
	double m_SampleFreq;
// PSK31 and CW generator variables
	double m_t;
	INT m_Ramp;
	double m_RMSConstant;
	double m_2PI;
	double m_PSKSecPerSamp;
	double m_PSKTime;
	double m_PSKPeriodUpdate;
	double m_PSKPhaseInc;
	WORD m_TxShiftReg;
	WORD m_TxCodeWord;
	INT m_PSKmode;
	double* m_pPSKtxI;
	double* m_pPSKtxQ;
	BYTE m_PresentPhase;
	BYTE m_Lastsymb;
	INT m_CWState;
	INT m_CWtimer;
	BOOL m_AddEndingZero;

// PSK31 and CW modulator private functions
	INT GetChar( );
	BYTE GetNextBPSKSymbol(void);
	BYTE GetNextQPSKSymbol(void);
	BYTE GetNextCWSymbol(void);
	BYTE MakeTestChar();
};

#endif // !defined(AFX_PSKMod_H__ACB4CEA2_C356_11D2_88B9_444553540000__INCLUDED_)
