// PskDet.h: interface for the CPskDet class.
//
//////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_PskDet_H__0C099641_E9AB_11D2_88B9_444553540000__INCLUDED_)
#define AFX_PskDet_H__0C099641_E9AB_11D2_88B9_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <math.h>
#include "WinPSKDoc.h"

struct SurvivorStates{
	double Pathdistance;	// sum of all metrics for a given survivor path
	LONG BitEstimates;		// the bit pattern estimate associated with given survivor path
};

class CPskDet  
{
public:
	CPskDet();
	virtual ~CPskDet();
	BOOL Init(double Fs ,INT BlockSize);
	double ProcPskDet( double* pIn, CWinPSKDoc* pDoc , INT Freq, BOOL UseAFC);

private:
	INT m_ClkErrTimer;
	INT m_ClkErrCounter;
	INT m_ClkError;
//methods
	double CalcDistance( _complex newsymb, BYTE symb);
	BOOL ViterbiDecode( double newangle,BOOL UseMaxLikely);
	BOOL GetBPSKSymb(BOOL UseMaxLikely);
	void DecodeSymb( _complex newsamp , CWinPSKDoc* pDoc);
	void GetQPSKSymb();
	void CalcQuality(CWinPSKDoc* pDoc, double angle );
	BOOL SymbSync(_complex sample, CWinPSKDoc* pDoc);
	void CalcBitFilter(  _complex Samp);
	double CalcAGC( _complex Samp );
	double CalcFreqError( _complex IQ, CWinPSKDoc* pDoc );
//variables
	double m_QPSKprob[4];
	INT m_LastPkPos;
	INT m_OnCount;
	INT m_OffCount;
	INT m_TrigInhib;
	INT m_SampCnt;
	BOOL m_DispTrig;
	double m_DevAve;
	double m_I0;		// 4 stage I/Q delay line variables
	double m_I1;
	double m_I2;
	double m_I3;
	double m_Q0;
	double m_Q1;
	double m_Q2;
	double m_Q3;
	INT m_BlockSize;
	double m_BitPhaseInc;
	double m_BitPhasePos;
	double m_SyncAve[21];
	double m_SignalLevel;
	double m_Fs;

	_complex* m_pQue1;
	_complex* m_pQue2;
	_complex* m_pQue3;
	_complex* m_pInPtr1;
	_complex* m_pInPtr2;
	_complex* m_pInPtr3;
	BYTE* m_VaricodeDecTbl;

	_complex m_FreqSignal;
	_complex m_BitSignal;
	double m_phzinc;
	WORD m_BitAcc;
	BOOL m_LastBitZero;
	struct SurvivorStates m_SurvivorStates[16]; /* Survivor path trellis */

// Local variables for various functions that need to be saved between calls
	double m_AGCave;
	_complex m_z1;
	_complex m_z2;
	double m_FerAve;

	INT m_LastFreq;
	double m_FreqError;
	double m_QFreqError;
	double m_VcoPhz;
	INT	m_PkPos;
	INT	m_NewPkPos;
	INT m_BitPos;
};

#endif // !defined(AFX_PskDet_H__0C099641_E9AB_11D2_88B9_444553540000__INCLUDED_)
