// SetDlg.cpp : implementation file
//
//

#include "stdafx.h"
#include "winpsk.h"
#include "SetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetDlg dialog


CSetDlg::CSetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetDlg)
	m_sCallSign = _T("");
	m_PTTPort = -1;
	m_UseSlash = FALSE;
	m_ClockAdj = 0;
	m_UseLSB = FALSE;
	m_UseMaxLikelyDet = TRUE;
	m_EchoTXText = FALSE;
	m_UseLocalTime = FALSE;
	//}}AFX_DATA_INIT
}


void CSetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetDlg)
	DDX_Text(pDX, IDC_CALLSIGNEDIT, m_sCallSign);
	DDX_Radio(pDX, IDC_PTTNONE, m_PTTPort);
	DDX_Check(pDX, IDC_USESLASH, m_UseSlash);
	DDX_Text(pDX, IDC_CLKADJ, m_ClockAdj);
	DDV_MinMaxInt(pDX, m_ClockAdj, -5000, 5000);
	DDX_Check(pDX, IDC_USELSB, m_UseLSB);
	DDX_Check(pDX, IDC_MAXLIKELY, m_UseMaxLikelyDet);
	DDX_Check(pDX, IDC_ECHOTXTEXT, m_EchoTXText);
	DDX_Check(pDX, IDC_USELOCALTIME, m_UseLocalTime);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetDlg, CDialog)
	//{{AFX_MSG_MAP(CSetDlg)
	ON_NOTIFY(UDN_DELTAPOS, IDC_CLKADJSPIN, OnDeltaposClkadjspin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


///////////////////////////////////////////////////////////////////////////////
//  return TRUE if com port(n) exists
///////////////////////////////////////////////////////////////////////////////
BOOL CSetDlg::PortExists(INT n)
{
char szPort[10];
HANDLE hComPort;
	wsprintf( szPort, "COM%d", n );
	hComPort = CreateFile( szPort, 0, 0, NULL,
						OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if( hComPort == INVALID_HANDLE_VALUE )
		return( FALSE );
	CloseHandle( hComPort );
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
//  Initialize check box states with current settings
///////////////////////////////////////////////////////////////////////////////
BOOL CSetDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
CWnd* pWnd;	
	pWnd = GetDlgItem( IDC_PTTCOM1 );
	if( PortExists(1) )
	{
		pWnd->EnableWindow(TRUE);
		if( m_PTTPort == 1 )
			pWnd->CheckDlgButton( IDC_PTTCOM1, TRUE );
	}
	else
		pWnd->EnableWindow(FALSE);
	pWnd = GetDlgItem( IDC_PTTCOM2 );
	if( PortExists(2) )
	{
		pWnd->EnableWindow(TRUE);
		if( m_PTTPort == 2 )
			pWnd->CheckDlgButton( IDC_PTTCOM2, TRUE );
	}
	else
		pWnd->EnableWindow(FALSE);
	pWnd = GetDlgItem( IDC_PTTCOM3 );
	if( PortExists(3) )
	{
		pWnd->EnableWindow(TRUE);
		if( m_PTTPort == 3 )
			pWnd->CheckDlgButton( IDC_PTTCOM3, TRUE );
	}
	else
		pWnd->EnableWindow(FALSE);
	pWnd = GetDlgItem( IDC_PTTCOM4 );
	if( PortExists(4) )
	{
		pWnd->EnableWindow(TRUE);
		if( m_PTTPort == 4 )
			pWnd->CheckDlgButton( IDC_PTTCOM4, TRUE );
	}
	else
		pWnd->EnableWindow(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

///////////////////////////////////////////////////////////////////////////////
//  update the clock adjustment value when spin control is used.
///////////////////////////////////////////////////////////////////////////////
void CSetDlg::OnDeltaposClkadjspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	m_ClockAdj -= (100*pNMUpDown->iDelta);
	if(m_ClockAdj > 5000)
		m_ClockAdj = 5000;
	if(m_ClockAdj < -5000)
		m_ClockAdj = -5000;
	UpdateData(FALSE);		//Put changed data into control
	*pResult = 0;
}

