// Settings.cpp: implementation of the CSettings class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "WinPSK.h"
#include "Settings.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSettings::CSettings()
{

}

CSettings::~CSettings()
{

}


///////////////////////////////////////////////////////////////////////////////
// read setup info from file.  A \005 value is used to terminate all CStrings
///////////////////////////////////////////////////////////////////////////////
BOOL CSettings::ReadFromFile(CString filename)
{
FILE* stream;
INT cRead;

BYTE x1,x2,x3,x4,x5,x6,x7,x8;
	if( (stream = fopen( filename, "rb" ) )== NULL )
		return FALSE;
//get BOOL's
	cRead = fscanf(stream, "%i:%i:%i:%i:%i:%i:%i:%i\r\n",
		&m_UseMaxLikelyDet,
		&m_DemoMode,
		&m_UseAFC,
		&m_UseSlash,
		&m_fSlowAve,
		&m_TXNet,
		&m_UseLSB,
		&m_EchoTXText);
	if (cRead != 8)
	{
		fclose( stream );
		return FALSE;
	}
//Get INT's
	cRead = fscanf(stream, "%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:%i\r\n",
		&m_SNR,
		&m_SQThreshold,
		&m_TabSel,
		&m_RxFreq,
		&m_TxFreq,
		&m_ModType,
		&m_PTTPort,
		&m_PlotViewState[FFT_DISPVIEW].xcur,
		&m_PlotViewState[FFT_DISPVIEW].zoom,
		&m_PlotViewState[WATERFALL_DISPVIEW].xcur,
		&m_PlotViewState[WATERFALL_DISPVIEW].zoom,
		&m_ClockAdj);
	if (cRead != 12)
	{
		fclose( stream );
		return FALSE;
	}
//Get colors
	cRead = fscanf( stream, "%i:%i:%i:%i:%i\r\n",
		&m_crRcvBackColor,
		&m_crXmitBackColor,
		&m_crRcvTextColor,
		&m_crXmitTextColor,
		&m_crXmitSentTextColor);
	if (cRead != 5)
	{
		fclose( stream );
		return FALSE;
	}
//get fonts
	cRead = fscanf( stream, "%[^\005]\005\n%li:%li:%i:%i:%i:%i:%i:%i:%i:%i\r\n",
			m_lfRcvFont.lfFaceName,
			&m_lfRcvFont.lfWeight, 
			&m_lfRcvFont.lfHeight, 
			&x1,&x2,&x3,&x4,&x5,&x6,&x7,&x8);
	if (cRead != 11)
	{
		fclose( stream );
		return FALSE;
	}
	m_lfRcvFont.lfOutPrecision = x1;
	m_lfRcvFont.lfClipPrecision = x2;
	m_lfRcvFont.lfQuality = x3;
	m_lfRcvFont.lfItalic = x4;
	m_lfRcvFont.lfUnderline = x5;
	m_lfRcvFont.lfStrikeOut = x6;
	m_lfRcvFont.lfCharSet = x7;
	m_lfRcvFont.lfPitchAndFamily = x8;

	cRead = fscanf( stream, "%[^\005]\005\n%li:%li:%i:%i:%i:%i:%i:%i:%i:%i\r\n",
			m_lfXmitFont.lfFaceName,
			&m_lfXmitFont.lfWeight, 
			&m_lfXmitFont.lfHeight, 
			&x1,&x2,&x3,&x4,&x5,&x6,&x7,&x8);
	if (cRead != 11)
	{
		fclose( stream );
		return FALSE;
	}
	m_lfXmitFont.lfOutPrecision = x1;
	m_lfXmitFont.lfClipPrecision = x2;
	m_lfXmitFont.lfQuality = x3;
	m_lfXmitFont.lfItalic = x4;
	m_lfXmitFont.lfUnderline = x5;
	m_lfXmitFont.lfStrikeOut = x6;
	m_lfXmitFont.lfCharSet = x7;
	m_lfXmitFont.lfPitchAndFamily = x8;
	
	cRead = fscanf( stream, "%[^\005]\005\n%li:%li:%i:%i:%i:%i:%i:%i:%i:%i\r\n",
			m_lfXmitSentFont.lfFaceName,
			&m_lfXmitSentFont.lfWeight, 
			&m_lfXmitSentFont.lfHeight, 
			&x1,&x2,&x3,&x4,&x5,&x6,&x7,&x8);
	if (cRead != 11)
	{
		fclose( stream );
		return FALSE;
	}
	m_lfXmitSentFont.lfOutPrecision = x1;
	m_lfXmitSentFont.lfClipPrecision = x2;
	m_lfXmitSentFont.lfQuality = x3;
	m_lfXmitSentFont.lfItalic = x4;
	m_lfXmitSentFont.lfUnderline = x5;
	m_lfXmitSentFont.lfStrikeOut = x6;
	m_lfXmitSentFont.lfCharSet = x7;
	m_lfXmitSentFont.lfPitchAndFamily = x8;

//get macro strings
	CString cstrg;				//***** compiler bug? -- if this is at beginning
								// of this routine and use speed optimization,
								// the CString object is out of scope at this
								// point.
	for( INT i=0; i<NUM_MACROS; i++)
	{
		if( !ReadCString( stream, cstrg) )
		{
			fclose( stream );
			return FALSE;
		}
		m_saMacroTitle.InsertAt(i, cstrg);
		if( !ReadCString( stream, cstrg) )
		{
			fclose( stream );
			return FALSE;
		}
		m_saMacroData.InsertAt(i, cstrg);
	}
//get other strings
	if( !ReadCString( stream, m_sMyCall) )
	{
		fclose( stream );
		return FALSE;
	}
// Any variables that were added after release 1.0 are read from the end
	cRead = fscanf(stream, "%i:\r\n", &m_UseLocalTime );	//version 1.10
	if (cRead != 1)
	{
		m_UseLocalTime = FALSE;		// if older version then set default
	}
	fclose( stream );
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
// reads a CString object from the file stream.
///////////////////////////////////////////////////////////////////////////////
BOOL CSettings::ReadCString(FILE * stream, CString& strg)
{
LPTSTR pBuf;
BOOL ret = FALSE;
	pBuf = strg.GetBuffer( 2048 );
	INT	cRead = fscanf( stream, "%[^\005]\005", pBuf);
	if(cRead == 0)				//deal with null string which doesn't
	{							// inc stream ptr.
		CHAR c = fgetc( stream);// read past terminator char \005
		if( c==5 )
		{
			strg = "";
			ret = TRUE;
		}
	}
	strg.ReleaseBuffer(-1);
	if(cRead == 1)
	{
		ret = TRUE;
	}
	return ret;
}

///////////////////////////////////////////////////////////////////////////////
// writes a CString object to the file stream.
///////////////////////////////////////////////////////////////////////////////
BOOL CSettings::WriteCString(FILE * stream, CString& strg)
{
LPTSTR pBuf;
BOOL ret = TRUE;
	pBuf = strg.GetBuffer( 2048 );
	if( fprintf( stream, "%s\005", pBuf) <= 0)
		ret = FALSE;
	strg.ReleaseBuffer(-1);
	return ret;
}

///////////////////////////////////////////////////////////////////////////////
// write setup info to file.  A \005 value is used to terminate all CStrings
///////////////////////////////////////////////////////////////////////////////
BOOL CSettings::WriteToFile(CString filename)
{
FILE* stream;
	if( (stream = fopen( filename, "wb+" ) )== NULL )
		return FALSE;
//save BOOL's
	fprintf( stream, "%i:%i:%i:%i:%i:%i:%i:%i\r\n",
		m_UseMaxLikelyDet,
		m_DemoMode,
		m_UseAFC,
		m_UseSlash,
		m_fSlowAve,
		m_TXNet,
		m_UseLSB,
		m_EchoTXText);
//save INT's
	fprintf( stream, "%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:%i:%i\r\n",
		m_SNR,
		m_SQThreshold,
		m_TabSel,
		m_RxFreq,
		m_TxFreq,
		m_ModType,
		m_PTTPort,
		m_PlotViewState[FFT_DISPVIEW].xcur,
		m_PlotViewState[FFT_DISPVIEW].zoom,
		m_PlotViewState[WATERFALL_DISPVIEW].xcur,
		m_PlotViewState[WATERFALL_DISPVIEW].zoom,
		m_ClockAdj);
// save colors	
	fprintf( stream, "%i:%i:%i:%i:%i\r\n",
		m_crRcvBackColor,
		m_crXmitBackColor,
		m_crRcvTextColor,
		m_crXmitTextColor,
		m_crXmitSentTextColor);
//save fonts
	fprintf( stream, "%s\005\n%li:%li:%i:%i:%i:%i:%i:%i:%i:%i\r\n",
		m_lfRcvFont.lfFaceName,
		m_lfRcvFont.lfWeight,
		m_lfRcvFont.lfHeight,
		m_lfRcvFont.lfOutPrecision,
		m_lfRcvFont.lfClipPrecision,
		m_lfRcvFont.lfQuality,
		m_lfRcvFont.lfItalic,
		m_lfRcvFont.lfUnderline,
		m_lfRcvFont.lfStrikeOut,
		m_lfRcvFont.lfCharSet,
		m_lfRcvFont.lfPitchAndFamily);
	fprintf( stream, "%s\005\n%li:%li:%i:%i:%i:%i:%i:%i:%i:%i\r\n",
		m_lfXmitFont.lfFaceName,
		m_lfXmitFont.lfWeight,
		m_lfXmitFont.lfHeight,
		m_lfXmitFont.lfOutPrecision,
		m_lfXmitFont.lfClipPrecision,
		m_lfXmitFont.lfQuality,
		m_lfXmitFont.lfItalic,
		m_lfXmitFont.lfUnderline,
		m_lfXmitFont.lfStrikeOut,
		m_lfXmitFont.lfCharSet,
		m_lfXmitFont.lfPitchAndFamily);

	fprintf( stream, "%s\005\n%li:%li:%i:%i:%i:%i:%i:%i:%i:%i\r\n",
		m_lfXmitSentFont.lfFaceName,
		m_lfXmitSentFont.lfWeight,
		m_lfXmitSentFont.lfHeight,
		m_lfXmitSentFont.lfOutPrecision,
		m_lfXmitSentFont.lfClipPrecision,
		m_lfXmitSentFont.lfQuality,
		m_lfXmitSentFont.lfItalic,
		m_lfXmitSentFont.lfUnderline,
		m_lfXmitSentFont.lfStrikeOut,
		m_lfXmitSentFont.lfCharSet,
		m_lfXmitSentFont.lfPitchAndFamily);

//save macro strings
	for( INT i=0; i<NUM_MACROS; i++)
	{
		if( !WriteCString( stream, m_saMacroTitle[i]) )
		{
			fclose( stream );
			return FALSE;
		}
		if( !WriteCString( stream, m_saMacroData[i]) )
		{
			fclose( stream );
			return FALSE;
		}
	}
	

//save other strings
	if( !WriteCString( stream, m_sMyCall ) )
	{
		fclose( stream );
		return FALSE;
	}
// Any variables that were added after release 1.0 are placed at the end
	fprintf( stream, "%i:\r\n",	m_UseLocalTime );	//added version 1.10

	if( fclose( stream ) )
		return FALSE;

	return TRUE;
}

