// Settings.h: interface for the CSettings class.
//
//////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_SETTINGS_H__0A86FC41_C99E_11D2_88B9_444553540000__INCLUDED_)
#define AFX_SETTINGS_H__0A86FC41_C99E_11D2_88B9_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "mmsystem.h"

#define FFT_DISPVIEW 0			//TAB controls for signal view display selection
#define WATERFALL_DISPVIEW 1
#define INPUT_DISPVIEW 2
#define SYNC_DISPVIEW 3

#define QPSK_MODE 0				// used to specify which mode to use
#define BPSK_MODE 1
#define CW_MODE 2

#define PTT_NONE 0				//COM port selections
#define PTT_COM1 1
#define PTT_COM2 2
#define PTT_COM3 3
#define PTT_COM4 4

#define NUM_MACROS 6		//Number of MACROS allowed

typedef struct
{
	INT xcur;
	INT zoom;
}StructDispSave;


class CSettings  
{
public:
	CSettings();
	virtual ~CSettings();
	BOOL WriteToFile( CString filename );
	BOOL ReadFromFile( CString filename );
//	User settings Variables that are saved
	BOOL m_UseMaxLikelyDet;
	BOOL m_DemoMode;
	BOOL m_fSlowAve;
	BOOL m_UseSlash;
	BOOL m_UseAFC;
	BOOL m_TXNet;
	BOOL m_UseLSB;
	BOOL m_EchoTXText;
	BOOL m_UseLocalTime;
	INT m_SNR;
	INT m_SQThreshold;
	INT m_ModType;
	INT m_ClockAdj;
	UINT m_PTTPort;
	UINT m_RxFreq;
	UINT m_TxFreq;
	CString m_sMyCall;
	CStringArray m_saMacroData;
	CStringArray m_saMacroTitle;
	LOGFONT m_lfRcvFont;
	LOGFONT m_lfXmitFont;
	LOGFONT m_lfXmitSentFont;
	COLORREF m_crRcvBackColor;
	COLORREF m_crXmitBackColor;
	COLORREF m_crRcvTextColor;
	COLORREF m_crXmitTextColor;
	COLORREF m_crXmitSentTextColor;
	INT m_TabSel;
	StructDispSave m_PlotViewState[SYNC_DISPVIEW+1];
private:
	BOOL WriteCString(FILE * stream, CString& strg);
	BOOL ReadCString( FILE* stream, CString& strg);

};

#endif // !defined(AFX_SETTINGS_H__0A86FC41_C99E_11D2_88B9_444553540000__INCLUDED_)
