// WinPSKDoc.cpp : implementation of the CWinPSKDoc class
//
//////////////////////////////////////////////////////////////////////
//

#include "stdafx.h"
#include "WinPSK.h"
#include "WinPSKDoc.h"
#include "IOCntrl.h"
#include "WinPSKView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RMS_AMPLITUDE (4739/2)		// max value for noise generator to stay in 15 bits
#define QUEUE_MOD_MASK 0x0003	//modulo 4 character tx queue pointers

/////////////////////////////////////////////////////////////////////////////
// CWinPSKDoc

IMPLEMENT_DYNCREATE(CWinPSKDoc, CDocument)

BEGIN_MESSAGE_MAP(CWinPSKDoc, CDocument)
	//{{AFX_MSG_MAP(CWinPSKDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinPSKDoc construction/destruction

CWinPSKDoc::CWinPSKDoc()
{
	m_pRcvEdit = NULL;
	m_pXmitEdit = NULL;
	m_pTheirCallEdit = NULL;
	m_pWinPSKView = NULL;
	m_pInputData = NULL;
	m_hRcvEditCtrl = NULL;
	m_hXmitEditCtrl = NULL;
	m_TXState = TX_OFF_STATE;
	m_DispBusy = TRUE;
	m_StopAfterText = FALSE;
	m_MacroStartTX = FALSE;
	m_NeedCWid = FALSE;
	m_UseNarrowAFC = FALSE;
	m_EventHandles[EVENT_NEWDATA] = NULL;
	m_EventHandles[EVENT_SCRNUPDATE] = NULL;
	m_pHead = 0;
	m_pTail = 0;
	m_sTheirCall = "";
	InitializeCriticalSection(&m_CriticalSection);
}

CWinPSKDoc::~CWinPSKDoc()
{
	if(m_EventHandles[EVENT_NEWDATA] )
		CloseHandle(m_EventHandles[EVENT_NEWDATA]);
	if(m_EventHandles[EVENT_SCRNUPDATE] )
		CloseHandle(m_EventHandles[EVENT_SCRNUPDATE]);
	if( m_pSettings != NULL)
		delete m_pSettings;
	if( m_pInputData != NULL)
		delete m_pInputData;
	if( m_pIQDispData != NULL)
		delete m_pIQDispData;
	if(m_pXmitEdit)
		delete m_pXmitEdit;
	if(m_pRcvEdit)
		delete m_pRcvEdit;
	if(m_pTheirCallEdit)
		delete m_pTheirCallEdit;
	DeleteCriticalSection(&m_CriticalSection);
}

////////////////////////////////////////////////////////////////////////
//   Get user settings or load defaults
////////////////////////////////////////////////////////////////////////
BOOL CWinPSKDoc::OnNewDocument()
{
CString sFile = "Settings.dat";
	m_pSettings = NULL;
	m_pSettings = new CSettings;
	ASSERT(m_pSettings);
// load settings values that are not saved in the settings file.
	m_WFXSettings.wFormatTag = WAVE_FORMAT_PCM;
	m_WFXSettings.nChannels = 1;
	m_WFXSettings.wBitsPerSample = 16;
	m_WFXSettings.nSamplesPerSec = 11025;
	m_WFXSettings.nBlockAlign = 
			m_WFXSettings.nChannels *(m_WFXSettings.wBitsPerSample/8);
	m_WFXSettings.nAvgBytesPerSec = 
			m_WFXSettings.nSamplesPerSec *
			m_WFXSettings.nBlockAlign;
	m_WFXSettings.cbSize = 0;
//  clear out all the logfont memory before setting it's members
	memset(&m_pSettings->m_lfRcvFont, 0, sizeof m_pSettings->m_lfRcvFont);
	memset(&m_pSettings->m_lfXmitFont, 0, sizeof m_pSettings->m_lfXmitFont);
	memset(&m_pSettings->m_lfXmitSentFont, 0, sizeof m_pSettings->m_lfXmitSentFont);
	m_pSettings->m_saMacroData.SetSize(NUM_MACROS);	//set size of string array
	m_pSettings->m_saMacroTitle.SetSize(NUM_MACROS);//set size of string array
///////////////////////////////////////////////////////////////////////
	if(	m_pSettings->ReadFromFile( sFile ) == FALSE )
	{
/////////////////  Load default settings if settings file not found
	//BOOL's
		m_pSettings->m_UseMaxLikelyDet = TRUE;
		m_pSettings->m_DemoMode = TRUE;
		m_pSettings->m_UseAFC = TRUE;
		m_pSettings->m_UseSlash = TRUE;
		m_pSettings->m_fSlowAve = FALSE;
		m_pSettings->m_TXNet = TRUE;
		m_pSettings->m_UseLSB = FALSE;
		m_pSettings->m_EchoTXText = TRUE;
		m_pSettings->m_UseLocalTime = FALSE;
	//INT's
		m_pSettings->m_TabSel = FFT_DISPVIEW;
		m_pSettings->m_RxFreq = 1000;
		m_pSettings->m_TxFreq = 1000;
		m_pSettings->m_ModType = BPSK_MODE;
		m_pSettings->m_PTTPort = PTT_NONE;
		m_pSettings->m_SQThreshold = 25;
		m_pSettings->m_SNR = 200;
		m_pSettings->m_ClockAdj = 0;

		m_pSettings->m_PlotViewState[FFT_DISPVIEW].xcur = 1000;
		m_pSettings->m_PlotViewState[FFT_DISPVIEW].zoom = 1;

		m_pSettings->m_PlotViewState[WATERFALL_DISPVIEW].xcur = 1000;
		m_pSettings->m_PlotViewState[WATERFALL_DISPVIEW].zoom = 1;

		m_pSettings->m_PlotViewState[INPUT_DISPVIEW].xcur = 0;
		m_pSettings->m_PlotViewState[INPUT_DISPVIEW].zoom = 8;
//colors	
		m_pSettings->m_crRcvBackColor = RGB(0,0,0);
		m_pSettings->m_crXmitBackColor = RGB(0,0,0);
		m_pSettings->m_crRcvTextColor = RGB(0,255,0);
		m_pSettings->m_crXmitTextColor = RGB(255,0,0);
		m_pSettings->m_crXmitSentTextColor = RGB(255,255,0);
// set a default font for receive and xmit edit boxes
		m_pSettings->m_lfRcvFont.lfHeight = -10;
		lstrcpy(m_pSettings->m_lfRcvFont.lfFaceName, _T("Arial"));
		m_pSettings->m_lfRcvFont.lfOutPrecision = OUT_TT_PRECIS;
		m_pSettings->m_lfRcvFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
		m_pSettings->m_lfRcvFont.lfQuality = PROOF_QUALITY;
		m_pSettings->m_lfRcvFont.lfPitchAndFamily = FF_SWISS | VARIABLE_PITCH;
//
		m_pSettings->m_lfXmitFont.lfHeight = -10;
		lstrcpy(m_pSettings->m_lfXmitFont.lfFaceName, _T("Arial"));
		m_pSettings->m_lfXmitFont.lfOutPrecision = OUT_TT_PRECIS;
		m_pSettings->m_lfXmitFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
		m_pSettings->m_lfXmitFont.lfQuality = PROOF_QUALITY;
		m_pSettings->m_lfXmitFont.lfPitchAndFamily = FF_SWISS | VARIABLE_PITCH;
//
		m_pSettings->m_lfXmitSentFont.lfHeight = -10;
		lstrcpy(m_pSettings->m_lfXmitSentFont.lfFaceName, _T("Arial"));
		m_pSettings->m_lfXmitSentFont.lfOutPrecision = OUT_TT_PRECIS;
		m_pSettings->m_lfXmitSentFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
		m_pSettings->m_lfXmitSentFont.lfQuality = PROOF_QUALITY;
		m_pSettings->m_lfXmitSentFont.lfPitchAndFamily = FF_SWISS | VARIABLE_PITCH;
//Initialize macros
		m_pSettings->m_saMacroTitle.InsertAt(0, _T("QSO Start"));
		m_pSettings->m_saMacroData.InsertAt(0, _T("'theircall' de 'mycall'"));

		m_pSettings->m_saMacroTitle.InsertAt(1, _T("QSO BTU"));
		m_pSettings->m_saMacroData.InsertAt(1, _T("BTU 'theircall' de 'mycall' kn'cwid''stop'"));

		m_pSettings->m_saMacroTitle.InsertAt(2, _T("QSO Final"));
		m_pSettings->m_saMacroData.InsertAt(2, _T(" 73's sk sk 'theircall' de 'mycall' cl'cwid''stop'"));

		m_pSettings->m_saMacroTitle.InsertAt(3, _T("CQ"));
		m_pSettings->m_saMacroData.InsertAt(3, _T("'start'\r\nCQ CQ CQ de 'mycall' 'mycall'\r\nCQ CQ CQ de 'mycall' 'mycall'\r\nCQ CQ CQ de 'mycall' 'mycall' k k k 'cwid''stop'"));

		m_pSettings->m_saMacroTitle.InsertAt(4, _T("Brag File"));
		m_pSettings->m_saMacroData.InsertAt(4, _T("<brag.txt>"));

		m_pSettings->m_saMacroTitle.InsertAt(5, _T("Undefined"));
		m_pSettings->m_saMacroData.InsertAt(5, _T(""));
// Strings
		m_pSettings->m_sMyCall = _T("No Callsign Set");
	}
///////////////////////////////////////////////////////////////////////////
//  Init some variables that are not save in "Settings.dat"
	m_pInputData = new double[FFT_SIZE];
	ASSERT(m_pInputData);
	m_pIQDispData = new _complex[250];	// at least data block size/9 (2048/9)
	ASSERT(m_pIQDispData);
	for( INT i=0; i<20; i++)
		m_SyncHist[i] = 0;
	m_EventHandles[EVENT_NEWDATA] = CreateEvent(NULL, FALSE,FALSE,NULL);
	m_EventHandles[EVENT_SCRNUPDATE] = CreateEvent(NULL, FALSE,FALSE,NULL);
	m_XmitWindowEmpty = TRUE;
	m_XmitFinished = TRUE;
	m_SoundCardReset = FALSE;
	Calc_SNR((double)m_pSettings->m_SNR/10.0);
	m_CWIdString = _T("de ") + m_pSettings->m_sMyCall;
	m_ClkError = 0;
	m_FastDemo = FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CWinPSKDoc serialization to file
/////////////////////////////////////////////////////////////////////////////
void CWinPSKDoc::Serialize(CArchive& ar)
{
PCHAR pbuf;
INT length;
	if (ar.IsStoring())
	{
		length = m_pRcvEdit->GetTextLength();
		pbuf = new CHAR[length+10];
		m_pRcvEdit->SetSel(0,-1);
		m_pRcvEdit->GetSelText( pbuf );
		m_pRcvEdit->SetSel(length,length);
		for( INT i=0; i<length; i++)
			ar << pbuf[i];
		delete pbuf;
	}
	else
	{
		// add text loading code here maybe
	}

	// Calling the base class COleDocument enables serialization
	//  of the container document's COleClientItem objects.
	CDocument::Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CWinPSKDoc diagnostics

#ifdef _DEBUG
void CWinPSKDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CWinPSKDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWinPSKDoc commands
/////////////////////////////////////////////////////////////////////////////
void CWinPSKDoc::OnCloseDocument() 
{
CString sFile = "Settings.dat";				// save user settings.dat file
	m_pSettings->WriteToFile( sFile );
	CDocument::OnCloseDocument();
}

/////////////////////////////////////////////////////////////////////////////
//   Calculate noise and signal amplitudes from SNR value.
// Tried to make SNR = Eb/No but maybe screwed up.  Measured RMS noise through
// Bit filter and PSK31 signal through bit filter.  Amplitude where they were
// equal was called 0 dB.
 //////////////////////////////////////////////////////////////////////////
void CWinPSKDoc::Calc_SNR( double val)
{
double SNRatio;
	SNRatio = val-20.9;		//convert from Eb/No where SNR=0 when RMS of signal
							// equals RMS of noise out of bit filter.
	if( SNRatio >= 0.0 )
	{
		m_SignalAmplitude = RMS_AMPLITUDE;
		m_NoiseAmplitude = RMS_AMPLITUDE/pow(10 , SNRatio/20.0);
	}
	else
	{
		m_NoiseAmplitude = RMS_AMPLITUDE;
		m_SignalAmplitude = RMS_AMPLITUDE*pow(10 , SNRatio/20.0);
	}
	m_pSettings->m_SNR = (INT)(val*10.0);
}

/////////////////////////////////////////////////////////////////////////////
//		TX Queueing routines
/////////////////////////////////////////////////////////////////////////////
INT CWinPSKDoc::GetTxChar()
{
INT ch;
	EnterCriticalSection(&m_CriticalSection);
	if( m_pHead != m_pTail )
	{
		ch = m_pXmitQue[m_pTail++];
		m_pTail = m_pTail&QUEUE_MOD_MASK;
	}
	else
		ch = TXTOG_CODE;		// if que is empty return TXTOG_CODE
	LeaveCriticalSection(&m_CriticalSection);
	return ch;
}

/////////////////////////////////////////////////////////////////////////////
void CWinPSKDoc::PutTxChar(INT ch)
{
	EnterCriticalSection(&m_CriticalSection);
	m_pXmitQue[m_pHead++] = ch;
	m_pHead = m_pHead&QUEUE_MOD_MASK;
	m_XmitFinished = FALSE;
	LeaveCriticalSection(&m_CriticalSection);
}

//////////////////////////////////////////////////////////////////
// return TRUE if can only hold one more character
//////////////////////////////////////////////////////////////////
BOOL CWinPSKDoc::IsTxQueFull()
{
INT tmpHead = m_pHead+1;
BOOL result = FALSE;
	tmpHead = tmpHead&QUEUE_MOD_MASK;
	EnterCriticalSection(&m_CriticalSection);
	if( tmpHead==m_pTail)	//is it within one char of being full?
		result = TRUE;
	tmpHead = (tmpHead+1)&QUEUE_MOD_MASK;
	if( tmpHead==m_pTail)	//is it completely full?
		result = TRUE;
	LeaveCriticalSection(&m_CriticalSection);
	return( result);
}

/////////////////////////////////////////////////////////////////////////////
void CWinPSKDoc::ClearTxQue()
{
	m_pTail = m_pHead = 0;
}
