// WinPSKDoc.h : interface of the CWinPSKDoc class
//
//////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_WINPSKDOC_H__EFF3B52A_3631_11D3_B48C_E03851C10000__INCLUDED_)
#define AFX_WINPSKDOC_H__EFF3B52A_3631_11D3_B48C_E03851C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RcvEditCtrl.h"
#include "XmitEditCtrl.h"
#include "Settings.h"

#define TX_OFF_STATE 0			//TX is off
#define TX_SENDING_STATE 1		//TX is sending text
#define TX_PAUSED_STATE 2		//TX is paused
#define TX_PREAMBLE_STATE 3		//TX sending starting preamble
#define TX_POSTAMBLE_STATE 4	//TX sending ending posteamble
#define TX_CWID_STATE 5			//TX sending CW ID
#define TX_TUNE_STATE 6			//TX is tuning mode

#define EVENT_NEWDATA 0
#define EVENT_SCRNUPDATE 1
#define RCV_FONT_ID 0
#define XMIT_FONT_ID 1

class CWinPSKDoc : public CDocument
{
protected: // create from serialization only
	CWinPSKDoc();
	DECLARE_DYNCREATE(CWinPSKDoc)

// Attributes
public:
// Operations
public:
	void Calc_SNR(double val);
	BOOL IsTxQueFull();
	void PutTxChar( INT ch);
	INT GetTxChar();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinPSKDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL m_UseNarrowAFC;
	BOOL m_FastDemo;
	BOOL m_SoundCardReset;
	INT m_ClkError;
	virtual ~CWinPSKDoc();
	void ClearTxQue();
// variables 
	CRcvEditCtrl* m_pRcvEdit;
	CXmitEditCtrl* m_pXmitEdit;
	CTheirCallCtrl* m_pTheirCallEdit;
	CFormView* m_pWinPSKView;
	CSettings* m_pSettings;
	HWND m_hRcvEditCtrl;
	HWND m_hXmitEditCtrl;

	
// variables used to communicate between threads and objects
//    (hopefully) they are thread safe.
	BOOL m_XmitWindowEmpty;
	BOOL m_XmitFinished;
	BOOL m_SquelchOn;
	BOOL m_DispBusy;
	BOOL m_StopAfterText;
	BOOL m_MacroStartTX;
	BOOL m_NeedCWid;
	BOOL m_TXNet;
	INT m_DispXmax;
	INT m_DispYmax;
	INT m_DispCFreq;
	INT m_FormHeight;
	INT m_SyncHist[21];
	INT m_SquelchLevel;
	INT m_TXState;
	CString m_CWIdString;
	CString m_sTheirCall;
	double* m_pInputData;
	double m_SignalAmplitude;
	double m_NoiseAmplitude;
	_complex* m_pIQDispData;
	HANDLE m_EventHandles[2];
	CRITICAL_SECTION m_CriticalSection;	// use for keeping threads
										// from stomping on each other
//+++++++++++++   WAVEFORMATEX  member variables     +++++++++++++++++++
//typedef struct { 
//    WORD  wFormatTag; 
//    WORD  nChannels; 
//    DWORD nSamplesPerSec; 
//    DWORD nAvgBytesPerSec; 
//    WORD  nBlockAlign; 
//    WORD  wBitsPerSample; 
//    WORD  cbSize; 
//} WAVEFORMATEX; 
	WAVEFORMATEX m_WFXSettings;		// input device settings
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	INT m_pTail;
	INT m_pHead;
	INT m_pXmitQue[16];

// Generated message map functions
protected:
	//{{AFX_MSG(CWinPSKDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WINPSKDOC_H__EFF3B52A_3631_11D3_B48C_E03851C10000__INCLUDED_)
