// WinPSKView.cpp : implementation of the CWinPSKView class
//
//////////////////////////////////////////////////////////////////////
//

#include "stdafx.h"
#include "WinPSK.h"
#include "IOCntrl.h"
#include "Macrodlg.h"
#include "WinPSKDoc.h"
#include "WinPSKView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PLOT_CHNG_MOUSE 0
#define PLOT_CHNG_ZOOM 1
#define PLOT_CHNG_FREQ 2

#define ID_TIMER 1
/////////////////////////////////////////////////////////////////////////////
// CWinPSKView

IMPLEMENT_DYNCREATE(CWinPSKView, CFormView)

BEGIN_MESSAGE_MAP(CWinPSKView, CFormView)
	//{{AFX_MSG_MAP(CWinPSKView)
	ON_WM_DESTROY()
	ON_NOTIFY(TCN_SELCHANGE, IDC_DISPLAYTAB, OnSelchangeDisplaytab)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_NOTIFY(UDN_DELTAPOS, IDC_ZOOM, OnDeltaposZoom)
	ON_NOTIFY(UDN_DELTAPOS, IDC_RXFREQSPIN, OnDeltaposRxFreqspin)
	ON_WM_LBUTTONDBLCLK()
	ON_BN_CLICKED(IDC_SLOWAVE, OnSlowave)
	ON_BN_CLICKED(IDC_AFC, OnAfc)
	ON_BN_CLICKED(IDC_TRBUTTON, OnTrbutton)
	ON_BN_CLICKED(IDC_BPSK, OnBpsk)
	ON_BN_CLICKED(IDC_QPSK, OnQpsk)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_TXPAUSE, OnTxpause)
	ON_BN_CLICKED(IDC_TXTUNE, OnTxtune)
	ON_BN_CLICKED(IDC_NET, OnNet)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditCut)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR, OnUpdateEditClear)
	ON_WM_CONTEXTMENU()
	ON_EN_KILLFOCUS(IDC_RXFREQ, OnKillfocusRxfreq)
	ON_EN_SETFOCUS(IDC_RXFREQ, OnSetfocusRxfreq)
	ON_EN_KILLFOCUS(IDC_TXFREQ, OnKillfocusTxfreq)
	ON_NOTIFY(UDN_DELTAPOS, IDC_TXFREQSPIN, OnDeltaposTxfreqspin)
	ON_BN_CLICKED(IDC_CWID, OnCwid)
	ON_EN_SETFOCUS(IDC_TXFREQ, OnSetfocusTxfreq)
	ON_BN_CLICKED(IDC_M1BUTTON, OnM1button)
	ON_BN_CLICKED(IDC_M2BUTTON, OnM2button)
	ON_BN_CLICKED(IDC_M3BUTTON, OnM3button)
	ON_BN_CLICKED(IDC_M4BUTTON, OnM4button)
	ON_BN_CLICKED(IDC_M5BUTTON, OnM5button)
	ON_BN_CLICKED(IDC_M6BUTTON, OnM6button)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinPSKView construction/destruction
/////////////////////////////////////////////////////////////////////////////
CWinPSKView::CWinPSKView()
	: CFormView(CWinPSKView::IDD)
{
	//{{AFX_DATA_INIT(CWinPSKView)
	m_RxFreq = 1;
	m_XMaxCStr = _T("");
	m_XMinCStr = _T("");
	m_ZoomTxt = _T("");
	m_fSlowAve = FALSE;
	m_UseAFC = FALSE;
	m_TXNet = FALSE;
	m_TxFreq = 1000;
	m_PSKMode = -1;
	//}}AFX_DATA_INIT
	m_pCPlotData = NULL;
	m_pIOCntrl = NULL;
	m_NeedUpdate = TRUE;
	m_fRxFreqEditing = FALSE;
	m_fTxFreqEditing = FALSE;
	m_pSquelchCtrl = NULL;
}

CWinPSKView::~CWinPSKView()
{
}

/////////////////////////////////////////////////////////////////////////////
void CWinPSKView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinPSKView)
	DDX_Control(pDX, IDC_AFC, m_AFCCtrl);
	DDX_Control(pDX, IDC_QPSK, m_QPSKCtrl);
	DDX_Control(pDX, IDC_TXTUNE, m_TXTuneCtrl);
	DDX_Control(pDX, IDC_TXPAUSE, m_PauseCtrl);
	DDX_Control(pDX, IDC_TRBUTTON, m_TRCntrl);
	DDX_Control(pDX, IDC_XMINTXT, m_XMinCntrl);
	DDX_Control(pDX, IDC_XMAXTXT, m_XMaxCntrl);
	DDX_Control(pDX, IDC_DISPLAYTAB, m_DispTabCtrl);
	DDX_Text(pDX, IDC_RXFREQ, m_RxFreq);
	DDX_Text(pDX, IDC_XMAXTXT, m_XMaxCStr);
	DDX_Text(pDX, IDC_XMINTXT, m_XMinCStr);
	DDX_Text(pDX, IDC_ZOOMTXT, m_ZoomTxt);
	DDX_Check(pDX, IDC_SLOWAVE, m_fSlowAve);
	DDX_Check(pDX, IDC_AFC, m_UseAFC);
	DDX_Check(pDX, IDC_NET, m_TXNet);
	DDX_Text(pDX, IDC_TXFREQ, m_TxFreq);
	DDX_Radio(pDX, IDC_QPSK, m_PSKMode);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_M1BUTTON, m_MTitleCtrl[0]);
	DDX_Control(pDX, IDC_M2BUTTON, m_MTitleCtrl[1]);
	DDX_Control(pDX, IDC_M3BUTTON, m_MTitleCtrl[2]);
	DDX_Control(pDX, IDC_M4BUTTON, m_MTitleCtrl[3]);
	DDX_Control(pDX, IDC_M5BUTTON, m_MTitleCtrl[4]);
	DDX_Control(pDX, IDC_M6BUTTON, m_MTitleCtrl[5]);
}

BOOL CWinPSKView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CFormView::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
//  Called to initialize the main FormView object.
/////////////////////////////////////////////////////////////////////////////
void CWinPSKView::OnInitialUpdate()
{
CSize size;
INT i;
	CFormView::OnInitialUpdate();
// save off original mouse cursor
	m_hOrigCursor =	(HCURSOR)::GetClassLong(GetSafeHwnd(),GCL_HCURSOR);
// get the system cross cursor for use when mouse goes over the plot
	m_hCross = AfxGetApp()->LoadStandardCursor(IDC_CROSS);

	m_TRCntrl.SetIcon(AfxGetApp()->LoadIcon(IDI_TRRCV));
	CWinPSKDoc* pDoc = (CWinPSKDoc*) GetDocument();
	ASSERT_VALID( pDoc);
	if (pDoc != NULL)
	{
		// create "theircall" edit box
		CRect cr;
		CWnd* pWnd = GetDlgItem( IDC_THEIRCALL );
		ASSERT_VALID(pWnd);
		pWnd->GetWindowRect( cr );
		ScreenToClient( cr);
		pDoc->m_pTheirCallEdit = new CTheirCallCtrl;
		pDoc->m_pTheirCallEdit->Create( WS_VISIBLE | WS_BORDER | WS_CHILD |
				WS_GROUP , cr, this, IDC_RICHEDIT3);
		//instantiate data plotting and processing thread objects
		m_pCPlotData = new CPlotData();		//initialize Data plotting resources
		ASSERT(m_pCPlotData);
		m_pIOCntrl = new CIOCntrl();
		ASSERT(m_pIOCntrl);
//
		pDoc->m_pWinPSKView = this;			//store this view ptr in Document class

		pWnd = GetDlgItem( IDC_PLOTAREA );
		ASSERT_VALID(pWnd);					//give ciew client area to Plot object
		pWnd->GetClientRect( cr );
		m_PlotWidth = cr.right;
		m_pCPlotData->SetPlotSize(cr); 

		CString str;
		str.LoadString(AFX_IDS_APP_TITLE);
		str = str + _T(" 1.2 - - ") + pDoc->m_pSettings->m_sMyCall;
		AfxGetMainWnd()->SetWindowText( str );

		m_pSquelchCtrl = new CSquelchCtrl();
		ASSERT_VALID(m_pSquelchCtrl);
		CRect r;
		GetDlgItem(IDC_SQUELCH)->GetWindowRect(r); 
		ScreenToClient(r);
		BOOL res = m_pSquelchCtrl->Create( "",WS_VISIBLE|WS_CHILD|WS_DLGFRAME,
												r, this, IDC_SQUELCH);
		m_pSquelchCtrl->SetThreshold( pDoc->m_pSettings->m_SQThreshold);
		m_pSquelchCtrl->SetLevel(0);


// Initialize controls to values in "pDoc->m_Settings"		
		m_RxFreq = pDoc->m_pSettings->m_RxFreq;
		m_TxFreq = pDoc->m_pSettings->m_TxFreq;
		m_PSKMode = pDoc->m_pSettings->m_ModType;
		m_UseAFC = pDoc->m_pSettings->m_UseAFC;
		m_TXNet = pDoc->m_pSettings->m_TXNet;
		m_fSlowAve = pDoc->m_pSettings->m_fSlowAve;
		if(pDoc->m_pSettings->m_UseLSB)
			m_QPSKCtrl.SetWindowText(_T("QPSK (lsb)"));
		else
			m_QPSKCtrl.SetWindowText(_T("QPSK (usb)"));

		for( i=0; i<NUM_MACROS; i++)
		{
			if( i == 0 )
				m_MTitleCtrl[i].SetWindowText( _T("(F11) ") +pDoc->m_pSettings->m_saMacroTitle[i]);
			else if( i == 1 )
				m_MTitleCtrl[i].SetWindowText( _T("(F12) ") + pDoc->m_pSettings->m_saMacroTitle[i]);
			else
				m_MTitleCtrl[i].SetWindowText( pDoc->m_pSettings->m_saMacroTitle[i]) ;
		}

		if( (pDoc->m_pSettings->m_TabSel == FFT_DISPVIEW ) ||
					(pDoc->m_pSettings->m_TabSel == WATERFALL_DISPVIEW ) )
		{
			m_ZoomOK = TRUE;
			m_pCPlotData->SetPlotCursorIndex( pDoc->m_pSettings->
						m_PlotViewState[pDoc->m_pSettings->m_TabSel].xcur );
			m_pCPlotData->SetZoom( pDoc->m_pSettings->
						m_PlotViewState[pDoc->m_pSettings->m_TabSel].zoom,TRUE );
		}
		else
			m_ZoomOK = FALSE;
		UpdatePlotInfo(PLOT_CHNG_ZOOM);
		UpdatePlotInfo(PLOT_CHNG_FREQ);
	}
//  Add plot display TAB control initialization here
TC_ITEM tci;
CString str;
	tci.mask = TCIF_TEXT;
	str = _T("Spectrum");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_DispTabCtrl.InsertItem(FFT_DISPVIEW, &tci);
	str = _T("Waterfall");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_DispTabCtrl.InsertItem(WATERFALL_DISPVIEW, &tci);
	str = _T("Input");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_DispTabCtrl.InsertItem(INPUT_DISPVIEW, &tci);
	str = _T("Data Sync");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_DispTabCtrl.InsertItem(SYNC_DISPVIEW, &tci);

	m_DispTabCtrl.SetCurSel(pDoc->m_pSettings->m_TabSel);
	m_TimerID = SetTimer( ID_TIMER, 500, NULL);	//start up status timer
	if( m_TimerID == 0)
		AfxMessageBox( _T("Can't Start Status Timer"),MB_OK );
//start up the external soundcard reading/writing process thread
	m_pIOCntrl->StartIO(pDoc);
}


/////////////////////////////////////////////////////////////////////////////
//  Called to release all the View object resources.
/////////////////////////////////////////////////////////////////////////////
void CWinPSKView::OnDestroy()
{
	CWinPSKDoc* pDoc = (CWinPSKDoc*) GetDocument();
	KillTimer(m_TimerID);
	if(m_pCPlotData)
	{
		m_pCPlotData->StopDrawThread();
		delete m_pCPlotData;
		m_pCPlotData = NULL;
	}
	if(m_pIOCntrl)
	{
		m_pIOCntrl->StopIO();
		delete m_pIOCntrl;
		m_pIOCntrl = NULL;
	}
	if (pDoc != NULL)
	{
		if(pDoc->m_pTheirCallEdit)
		{
			delete pDoc->m_pTheirCallEdit;
			pDoc->m_pTheirCallEdit = NULL;
		}

	}	
	if( m_pSquelchCtrl )
	{
		delete m_pSquelchCtrl;
		m_pSquelchCtrl = NULL;
	}
	CFormView::OnDestroy();
}


/////////////////////////////////////////////////////////////////////////////
// CWinPSKView diagnostics
/////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
void CWinPSKView::AssertValid() const
{
	CFormView::AssertValid();
}

void CWinPSKView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CWinPSKDoc* CWinPSKView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWinPSKDoc)));
	return (CWinPSKDoc*)m_pDocument;
}
#endif //_DEBUG

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//					CWinPSKView message handlers
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//////////////////////////////////////////////////////////////////////
// Called when view screen coordinates have changed.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnDraw(CDC* pDC) 
{
	//go recalculate & draw the data plots
	if(m_pCPlotData)
		m_pCPlotData->OnDrawPlot( m_hWnd, this, (CWinPSKDoc*)GetDocument() );
}

//////////////////////////////////////////////////////////////////////
// Called when mouse moves in view client window.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if( m_ZoomOK )
	{
		::SetClassLong(GetSafeHwnd(),GCL_HCURSOR,NULL);	//prevent flickering
		if( m_pCPlotData->CurInPlot(point) )
			::SetCursor( m_hCross );
		else
			::SetClassLong(GetSafeHwnd(),GCL_HCURSOR,(LONG)m_hOrigCursor);
	}
	CFormView::OnMouseMove(nFlags, point);
}

//////////////////////////////////////////////////////////////////////
// Called when left mouse button is clicked.
//  Frequency cursor is changed to the mouse position.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnLButtonDown(UINT nFlags, CPoint point) 
{
CWinPSKDoc* pDoc;
	if( m_ZoomOK )
	{
		if(m_pCPlotData->CurInPlot(point) )
		{
			pDoc = GetDocument();
			ASSERT_VALID( pDoc );
			m_fRxFreqEditing = FALSE;
			m_fTxFreqEditing = FALSE;
			SetAFCNarrow(FALSE);
			m_pCPlotData->SetPlotCursorPos( point.x );
			m_pCPlotData->SetZoom( pDoc->m_pSettings->m_PlotViewState
										[pDoc->m_pSettings->m_TabSel].zoom,FALSE );
			UpdatePlotInfo(PLOT_CHNG_MOUSE);
		}
	}
	SetFocus();
	CFormView::OnLButtonDown(nFlags, point);
}

//////////////////////////////////////////////////////////////////////
// Called when Slow fft average button is pushed.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnSlowave() 
{
	UpdateData(TRUE);		//Get value from control
	GetDocument()->m_pSettings->m_fSlowAve = m_fSlowAve;
}

//////////////////////////////////////////////////////////////////////
// Called when AFC button is pushed.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnAfc() 
{
	UpdateData(TRUE);		//Get value from control
	GetDocument()->m_pSettings->m_UseAFC = m_UseAFC;
}

//////////////////////////////////////////////////////////////////////
// Called when left mouse button is DOUBLE clicked.
//  Frequency is cursor changed to the mouse position and the view is
//  centered about the cursor.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
CWinPSKDoc* pDoc;
	if( m_ZoomOK )
	{
		if(m_pCPlotData->CurInPlot(point) )
		{
			pDoc = GetDocument();
			ASSERT_VALID( pDoc );
			SetAFCNarrow(FALSE);
			m_pCPlotData->SetPlotCursorPos( point.x );
			m_pCPlotData->SetZoom( pDoc->m_pSettings->m_PlotViewState
										[pDoc->m_pSettings->m_TabSel].zoom,FALSE );
			UpdatePlotInfo(PLOT_CHNG_MOUSE);
			m_pCPlotData->SetZoom(pDoc->m_pSettings->
							m_PlotViewState[pDoc->m_pSettings->m_TabSel].zoom,TRUE);
		}
	}
	CFormView::OnLButtonDblClk(nFlags, point);
}


//////////////////////////////////////////////////////////////////////
// Called when plot select tabs are clicked.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnSelchangeDisplaytab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	INT tab = m_DispTabCtrl.GetCurSel();
	CWinPSKDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	//save old tab state
	pDoc->m_pSettings->m_PlotViewState[pDoc->m_pSettings->m_TabSel].xcur =
							m_pCPlotData->GetPlotCursorIndex();
	pDoc->m_pSettings->m_PlotViewState[pDoc->m_pSettings->m_TabSel].zoom =
							m_pCPlotData->GetZoom();
	pDoc->m_pSettings->m_TabSel = tab;	// save new tab
	if( (tab == FFT_DISPVIEW ) || (tab == WATERFALL_DISPVIEW ) )
		m_ZoomOK = TRUE;
	else
		m_ZoomOK = FALSE;
	if( m_ZoomOK )
	{
		m_pCPlotData->SetPlotCursorIndex( pDoc->m_pSettings->m_PlotViewState[tab].xcur );
		m_pCPlotData->SetZoom( pDoc->m_pSettings->m_PlotViewState[tab].zoom,TRUE );
	}
	UpdatePlotInfo(PLOT_CHNG_ZOOM);
	UpdatePlotInfo(PLOT_CHNG_FREQ);
	UpdateData(FALSE);					//Put changed data into control
	m_pCPlotData->ClearBuffers();
	*pResult = 0;
}

//////////////////////////////////////////////////////////////////////
// Called when zoom spin control is clicked.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnDeltaposZoom(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	ChngZoom( -pNMUpDown->iDelta );
	*pResult = 0;
}


//////////////////////////////////////////////////////////////////////
// Called when RX freq edit box gets focus.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnSetfocusRxfreq() 
{
	m_fRxFreqEditing = TRUE;
}

//////////////////////////////////////////////////////////////////////
// Called when center frequency edit control is changed.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnKillfocusRxfreq() 
{
CWinPSKDoc* pDoc = GetDocument();
	UpdateData(TRUE);		//Get value from control
	if(m_RxFreq<MIN_FREQ)
		m_RxFreq = MIN_FREQ;
	if(m_RxFreq>MAX_FREQ)
		m_RxFreq = MAX_FREQ;
	EnterCriticalSection(&pDoc->m_CriticalSection);
	pDoc->m_pSettings->m_RxFreq = m_RxFreq;
	LeaveCriticalSection(&pDoc->m_CriticalSection);
	UpdateData(FALSE);		//Put changed data into control
	UpdatePlotInfo(PLOT_CHNG_FREQ);
	m_fRxFreqEditing = FALSE;
	m_fTxFreqEditing = FALSE;
}


//////////////////////////////////////////////////////////////////////
// Called when TX freq edit box gets focus.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnSetfocusTxfreq() 
{
	m_fTxFreqEditing = TRUE;
}

//////////////////////////////////////////////////////////////////////
// Called when TX freq edit box loses focus.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnKillfocusTxfreq() 
{
	UpdateData(TRUE);		//Get value from control
	if(m_TxFreq<MIN_FREQ)
		m_TxFreq = MIN_FREQ;
	if(m_TxFreq>MAX_FREQ)
		m_TxFreq = MAX_FREQ;
	GetDocument()->m_pSettings->m_TxFreq = m_TxFreq;
	UpdateData(FALSE);		//Put changed data into control
	m_fRxFreqEditing = FALSE;
	m_fTxFreqEditing = FALSE;

}

//////////////////////////////////////////////////////////////////////
// Called when TX freq Spin control is touched.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnDeltaposTxfreqspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	m_TxFreq -= pNMUpDown->iDelta;
	if(m_TxFreq<MIN_FREQ)
		m_TxFreq = MIN_FREQ;
	if(m_TxFreq>MAX_FREQ)
		m_TxFreq = MAX_FREQ;
	GetDocument()->m_pSettings->m_TxFreq = m_TxFreq;
	UpdateData(FALSE);		//Put changed data into control
	*pResult = 0;
	m_fRxFreqEditing = FALSE;
	m_fTxFreqEditing = FALSE;
}

//////////////////////////////////////////////////////////////////////
// Called when center frequency spin control is clicked.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnDeltaposRxFreqspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	ChngFreq( -pNMUpDown->iDelta );
	*pResult = 0;
	m_fRxFreqEditing = FALSE;
	m_fTxFreqEditing = FALSE;
	SetAFCNarrow(FALSE);
}

//////////////////////////////////////////////////////////////////////
//  Capture keystroke messages before they go to the controls so
// that custom functionality can be attached to certain keys.
//////////////////////////////////////////////////////////////////////
BOOL CWinPSKView::PreTranslateMessage(MSG* pMsg) 
{
BOOL fSkipMsg = FALSE;
CWinPSKDoc* pDoc;
	switch (pMsg->message)
	{
		case WM_KEYDOWN:
			switch (pMsg->wParam)
			{
				case VK_DOWN:
				case VK_LEFT:
				case VK_UP:
				case VK_RIGHT:
					pDoc = GetDocument();
					ASSERT_VALID( pDoc );
					m_fRxFreqEditing = FALSE;
					m_fTxFreqEditing = FALSE;
					SetAFCNarrow(FALSE);
					switch( pDoc->m_pSettings->m_TabSel )
					{
						case FFT_DISPVIEW:
						case WATERFALL_DISPVIEW:
							if( pMsg->wParam == VK_UP )
								ChngFreq(10);
							if( pMsg->wParam == VK_DOWN )
								ChngFreq(-10);
							if( pMsg->wParam == VK_RIGHT )
								ChngFreq(1);
							if( pMsg->wParam == VK_LEFT )
								ChngFreq(-1);
							break;
					}
					fSkipMsg = TRUE;
					break;
				case VK_NEXT:
					ChngZoom( -1 );
					break;
				case VK_PRIOR:
					ChngZoom( +1 );
					break;
				case VK_F2:
				case VK_F3:
				case VK_F4:
				case VK_F5:
				case VK_F6:
				case VK_F7:
				case VK_F8:
				case VK_F9:
				case VK_F10:
				case VK_F11:
				case VK_F12:
					ProcessFKeys(pMsg->wParam);
					break;
			}
			break;
	}
	if( fSkipMsg )
		return TRUE;
	else
		return CFormView::PreTranslateMessage(pMsg);
}

//////////////////////////////////////////////////////////////////////
// Called when Net check box is touched.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnNet() 
{
CWinPSKDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	UpdateData(TRUE);		//Get value from control
	pDoc->m_pSettings->m_TXNet = m_TXNet;
	if(m_TXNet )
	{
		pDoc->m_pSettings->m_TxFreq = m_RxFreq;
		m_TxFreq = m_RxFreq;
		UpdateData(FALSE);		//Put changed data into control
	}
}

//////////////////////////////////////////////////////////////////////
// Called when TR Button is pushed.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnTrbutton() 
{
	ToggleTR();
}
//////////////////////////////////////////////////////////////////////
// Called when BPSK Box is touched.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnBpsk() 
{
	UpdateData(TRUE);		//Get value from control
	GetDocument()->m_pSettings->m_ModType = m_PSKMode;
}

//////////////////////////////////////////////////////////////////////
// Called when QPSK Box is touched.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnQpsk() 
{
	UpdateData(TRUE);		//Get value from control
	GetDocument()->m_pSettings->m_ModType = m_PSKMode;
}


//////////////////////////////////////////////////////////////////////
// Called when TX  Pause Button is pressed.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnTxpause() 
{
CWinPSKDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	switch( pDoc->m_TXState )
	{
		case TX_OFF_STATE:
			break;
		case TX_TUNE_STATE:
			pDoc->m_TXState = TX_OFF_STATE;
			break;
		case TX_PAUSED_STATE:
			pDoc->m_TXState = TX_SENDING_STATE;
			break;
		case TX_SENDING_STATE:
			pDoc->m_TXState = TX_PAUSED_STATE;
			break;
	}
}

//////////////////////////////////////////////////////////////////////
// Called when TX Tune Button is pressed.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnTxtune() 
{
CWinPSKDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	SetAFCNarrow(TRUE);
	if( pDoc->m_TXState == TX_OFF_STATE)
	{
		pDoc->m_pRcvEdit->TXStamp(pDoc->m_pSettings->m_EchoTXText,
									TRUE, pDoc->m_pSettings->m_UseLocalTime);
		pDoc->m_TXState = TX_TUNE_STATE;
		OnNet();
	}
	else
		if( pDoc->m_TXState == TX_TUNE_STATE)
			pDoc->m_TXState = TX_OFF_STATE;	
	UpdateStatus();
}

//////////////////////////////////////////////////////////////////////
// Called when CWID Button is pressed.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnCwid() 
{
CWinPSKDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	SetAFCNarrow(TRUE);
	if( pDoc->m_TXState == TX_OFF_STATE)
	{
		pDoc->m_TXState = TX_CWID_STATE;
		OnNet();
		pDoc->m_pRcvEdit->TXStamp(pDoc->m_pSettings->m_EchoTXText,
									TRUE, pDoc->m_pSettings->m_UseLocalTime);
	}
	else
		if( pDoc->m_TXState == TX_SENDING_STATE)
			pDoc->m_NeedCWid = TRUE;
}

//////////////////////////////////////////////////////////////////////
//     General Functions for various chores
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
// Called to inc or dec frequency from control or keystrokes.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::ChngFreq(INT delta)
{
CWinPSKDoc* pDoc = GetDocument();
	if( !m_fRxFreqEditing && !m_fTxFreqEditing)
	{
		m_RxFreq += delta;
		if(m_RxFreq<MIN_FREQ)
			m_RxFreq = MIN_FREQ;
		if(m_RxFreq>MAX_FREQ)
			m_RxFreq = MAX_FREQ;
		EnterCriticalSection(&pDoc->m_CriticalSection);
		pDoc->m_pSettings->m_RxFreq = m_RxFreq;
		LeaveCriticalSection(&pDoc->m_CriticalSection);
		UpdateData(FALSE);		//Put changed data into control
		UpdatePlotInfo(PLOT_CHNG_FREQ);
	}
}

//////////////////////////////////////////////////////////////////////
// Called to use Wide or narrow AFC mode and label control accordingly.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::SetAFCNarrow(BOOL narrow)
{
	if(m_AFCCtrl.GetCheck() || !narrow)
	{
		CString sTxt;
		CWinPSKDoc* pDoc;
		pDoc = GetDocument();
		ASSERT_VALID( pDoc );
		m_AFCCtrl.GetWindowText( sTxt);
		pDoc->m_UseNarrowAFC = narrow;
		if(narrow)
			sTxt.LoadString(IDS_AFCNARROW);
		else
			sTxt.LoadString(IDS_AFCWIDE);
		m_AFCCtrl.SetWindowText( sTxt);
	}
}
//////////////////////////////////////////////////////////////////////
// Called to inc or dec zomm magnification from control or keystrokes.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::ChngZoom(INT delta)
{
INT tzoom;
	CWinPSKDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
// Get current zoom factor
	tzoom = pDoc->m_pSettings->m_PlotViewState[pDoc->m_pSettings->m_TabSel].zoom;
	tzoom += delta;		//change it
	if(tzoom < 1)		//clamp it
		tzoom = 1;
	if(tzoom >10)
		tzoom = 10;
	m_pCPlotData->SetZoom(tzoom,TRUE);	//recalculate screen
	pDoc->m_pSettings->m_PlotViewState[pDoc->m_pSettings->m_TabSel].zoom = tzoom;
	UpdatePlotInfo(PLOT_CHNG_ZOOM);
}
//////////////////////////////////////////////////////////////////////
// Converts display buffer index position to Frequency.
//////////////////////////////////////////////////////////////////////
INT CWinPSKView::IndexToFreq(INT Index)
{	//convert display buffer index to frequency Hz.
INT temp = ((Index)*FFT_SAMPLERATEX2*100)/(FFT_SIZE*2);	//100x freq
	if( (temp%100) > 50 )		//round to nearest fft index
		temp = temp/100 + 1;
	else
		temp = temp/100;
	return( temp);
}

//////////////////////////////////////////////////////////////////////
// Converts display buffer index position to Time in Msecs.
//////////////////////////////////////////////////////////////////////
INT CWinPSKView::IndexToTime(INT Index)
{	//convert display buffer index to time.
	return( (Index*2000/FFT_SAMPLERATEX2) );
}

//////////////////////////////////////////////////////////////////////
// Converts Frequency to display buffer index position.
//////////////////////////////////////////////////////////////////////
INT CWinPSKView::FreqToIndex(INT Freq)
{	//convert Frequency Hz to display buffer index.
INT temp = (Freq*FFT_SIZE*200)/FFT_SAMPLERATEX2;	//calc actual *100
	if( (temp%100) > 50 )		//round to nearest fft index
		temp = temp/100 + 1;
	else
		temp = temp/100;
	return( temp);
}

//////////////////////////////////////////////////////////////////////
// Updates the display controls depending on the view tab state and
//  where the change request is coming from(src = mouse,zoom,freq edit.)
//////////////////////////////////////////////////////////////////////
void CWinPSKView::UpdatePlotInfo(INT src)
{
CWnd* pWnd;
	CWinPSKDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	switch( src )
	{
		case PLOT_CHNG_MOUSE:
			switch( pDoc->m_pSettings->m_TabSel )
			{
				case FFT_DISPVIEW:
				case WATERFALL_DISPVIEW:
					m_RxFreq = IndexToFreq( m_pCPlotData->GetPlotCursorIndex() );
					EnterCriticalSection(&pDoc->m_CriticalSection);
					pDoc->m_pSettings->m_RxFreq = m_RxFreq;
					LeaveCriticalSection(&pDoc->m_CriticalSection);
					m_XMinCStr.Format("%d Hz", IndexToFreq( m_pCPlotData->GetXmin() ));
					m_XMaxCStr.Format("%d Hz", IndexToFreq( m_pCPlotData->GetXmax() ));
					break;
				default:
					m_XMinCStr = "0";
					m_XMaxCStr = "0";
					break;
			}
			break;
		case PLOT_CHNG_ZOOM:
			switch( pDoc->m_pSettings->m_TabSel )
			{
				case FFT_DISPVIEW:
				case WATERFALL_DISPVIEW:
					m_XMinCStr.Format("%d Hz", IndexToFreq( m_pCPlotData->GetXmin() ));
					m_XMaxCStr.Format("%d Hz", IndexToFreq( m_pCPlotData->GetXmax() ) );
					m_ZoomTxt.Format("Zoom X%d",pDoc->m_pSettings->m_PlotViewState[pDoc->m_pSettings->m_TabSel].zoom );
					pWnd = GetDlgItem( IDC_ZOOM );
					pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem( IDC_SLOWAVE );
					pWnd->EnableWindow(TRUE);
					break;
				case INPUT_DISPVIEW:
					m_XMinCStr = "0 Sec";
					m_XMaxCStr.Format("%3.2fSec", (float)m_PlotWidth/5512.5);
					m_ZoomTxt = "";
					pWnd = GetDlgItem( IDC_ZOOM );
					pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem( IDC_SLOWAVE );
					pWnd->EnableWindow(FALSE);
					break;
				default:
					m_XMinCStr = "";
					m_XMaxCStr = "";
					m_ZoomTxt = "";
					pWnd = GetDlgItem( IDC_ZOOM );
					pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem( IDC_SLOWAVE );
					pWnd->EnableWindow(FALSE);
					break;
			}
			break;
		case PLOT_CHNG_FREQ:
			switch( pDoc->m_pSettings->m_TabSel )
			{
				case FFT_DISPVIEW:
				case WATERFALL_DISPVIEW:
					m_pCPlotData->SetPlotCursorIndex(FreqToIndex(m_RxFreq) );
					m_pCPlotData->SetZoom( pDoc->m_pSettings->
						m_PlotViewState[pDoc->m_pSettings->m_TabSel].zoom,FALSE );
					break;
				default:
					break;
			}
			break;
	}
	UpdateData(FALSE);		//Put changed data into control
}


//////////////////////////////////////////////////////////////////////
// Called to process a Function key press.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::ProcessFKeys(WPARAM wParam)
{
	switch(wParam)
	{
		case VK_F2:
			break;
		case VK_F3:
			m_UseAFC = !m_UseAFC;
			GetDocument()->m_pSettings->m_UseAFC = m_UseAFC;
			UpdateData(FALSE);		//Put changed data into control
			OnAfc();
			break;
		case VK_F4:
			m_TXNet = !m_TXNet;
			GetDocument()->m_pSettings->m_TXNet = m_TXNet;
			UpdateData(FALSE);		//Put changed data into control
			OnNet();
			break;
		case VK_F5:
			ToggleTR();
			break;
		case VK_F6:
			OnCwid();
			break;
		case VK_F7:
			break;
		case VK_F8:
			OnTxtune();
			break;
		case VK_F9:
			OnTxpause();
			break;
		case VK_F11:
			OnM1button();
			break;
		case VK_F12:
			OnM2button();
			break;
	}
}

//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Called to toggle state of Transmit/Receive.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::ToggleTR()
{
CWinPSKDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	SetAFCNarrow(TRUE);
	switch( pDoc->m_TXState )
	{
		case TX_OFF_STATE:
			pDoc->m_TXState = TX_PREAMBLE_STATE;
			pDoc->ClearTxQue();
			pDoc->m_XmitWindowEmpty = FALSE;
			pDoc->m_XmitFinished = FALSE;
			OnNet();
			pDoc->m_pRcvEdit->CancelSelection();
			pDoc->m_pRcvEdit->TXStamp(pDoc->m_pSettings->m_EchoTXText,
								TRUE, pDoc->m_pSettings->m_UseLocalTime);
			pDoc->m_pXmitEdit->SetFocus();
			break;
		case TX_PAUSED_STATE:
			pDoc->m_TXState = TX_SENDING_STATE;
			pDoc->m_pXmitEdit->SetFocus();
			break;
		case TX_SENDING_STATE:
		case TX_PREAMBLE_STATE:
			pDoc->m_pXmitEdit->ClearSentText();
			pDoc->m_TXState = TX_POSTAMBLE_STATE;
			pDoc->m_StopAfterText = FALSE;
			break;
		case TX_TUNE_STATE:
		case TX_POSTAMBLE_STATE:
			pDoc->m_TXState = TX_OFF_STATE;
			break;
	}
}


//////////////////////////////////////////////////////////////////////
// Service timer for status updates.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnTimer(UINT nIDEvent) 
{
	if( nIDEvent == m_TimerID )
		UpdateStatus();
	CFormView::OnTimer(nIDEvent);
}

//////////////////////////////////////////////////////////////////////
// Called to update the button and other status states.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::UpdateStatus()
{
CWinPSKDoc* pDoc;
static BOOL tog = FALSE;
static INT laststate = TX_OFF_STATE;
	pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	INT i = pDoc->m_pSettings->m_RxFreq - m_RxFreq;
	if( i != 0  )
		ChngFreq( i );
	m_pSquelchCtrl->SetLevel( pDoc->m_SquelchLevel );
	pDoc->m_pSettings->m_SQThreshold = m_pSquelchCtrl->GetThreshold();
	if(pDoc->m_MacroStartTX) //if macro needs to turn on tx state
	{
		SetAFCNarrow(TRUE);
		if( pDoc->m_TXState == TX_OFF_STATE)
			ToggleTR();
		pDoc->m_MacroStartTX = FALSE;
	}
	switch( pDoc->m_TXState )
	{
		case TX_OFF_STATE:
			if( pDoc->m_TXState != laststate)
			{
				m_TRCntrl.SetIcon(AfxGetApp()->LoadIcon(IDI_TRRCV));
				pDoc->m_XmitFinished = FALSE;
				pDoc->m_pRcvEdit->TXStamp(pDoc->m_pSettings->m_EchoTXText,
									FALSE, pDoc->m_pSettings->m_UseLocalTime);
				pDoc->m_pXmitEdit->ClearSentText();
			}

			break;
		case TX_PAUSED_STATE:
			if(tog)
				m_TRCntrl.SetIcon(AfxGetApp()->LoadIcon(IDI_PAUSED));
			else
				m_TRCntrl.SetIcon(AfxGetApp()->LoadIcon(IDI_TROFF));
			break;
		case TX_TUNE_STATE:
			if(tog)
				m_TRCntrl.SetIcon(AfxGetApp()->LoadIcon(IDI_TUNE));
			else
				m_TRCntrl.SetIcon(AfxGetApp()->LoadIcon(IDI_TROFF));
			break;
		default:		// all other states are transmitting
			if(	 (pDoc->m_TXState==TX_SENDING_STATE)
					&& pDoc->m_XmitWindowEmpty
					&& pDoc->m_XmitFinished 
					&& pDoc->m_StopAfterText )
			{
				pDoc->m_TXState = TX_POSTAMBLE_STATE;
				pDoc->m_StopAfterText = FALSE;
			}
			if(tog)
				m_TRCntrl.SetIcon(AfxGetApp()->LoadIcon(IDI_TRXMIT));
			else
				m_TRCntrl.SetIcon(AfxGetApp()->LoadIcon(IDI_TROFF));
			break;
	}
	laststate = pDoc->m_TXState;
	tog = !tog;
}


////////////////////////////////////////////////////////////////////
////////////////////   ClipBoard Functionality    //////////////////
////////////////////////////////////////////////////////////////////
//  The receive window is read only so only copy operations are allowed
//  The transmit window can be pasted into but not copied from.
////////////////////////////////////////////////////////////////////
void CWinPSKView::OnEditCopy() 
{
CWinPSKDoc* pDoc = GetDocument();
CWnd* pWnd = GetFocus();
	if( pWnd == pDoc->m_pTheirCallEdit)
		pDoc->m_pTheirCallEdit->Copy();
	else
		if( pWnd == pDoc->m_pRcvEdit )
			pDoc->m_pRcvEdit->CopyClip();
}

void CWinPSKView::OnEditPaste() 
{
CWinPSKDoc* pDoc = GetDocument();
CWnd* pWnd = GetFocus();
	if( pWnd == pDoc->m_pTheirCallEdit)
		pDoc->m_pTheirCallEdit->PasteClip();
	else
		if( pWnd == pDoc->m_pXmitEdit )
		{
			pDoc->m_pXmitEdit->Paste();
			pDoc->m_pXmitEdit->SetFocus();
		}
}

void CWinPSKView::OnEditClear() 
{
CWinPSKDoc* pDoc = GetDocument();
CWnd* pWnd = GetFocus();
	if( pWnd == pDoc->m_pTheirCallEdit)
		pDoc->m_pTheirCallEdit->Clear();
	else
		if( pWnd == pDoc->m_pXmitEdit )
			pDoc->m_pXmitEdit->Clear();
}

void CWinPSKView::OnEditCut() 
{
CWinPSKDoc* pDoc = GetDocument();
CWnd* pWnd = GetFocus();
	if( pWnd == pDoc->m_pTheirCallEdit)
		pDoc->m_pTheirCallEdit->Cut();
	else
		if( pWnd == pDoc->m_pXmitEdit )
			pDoc->m_pXmitEdit->Cut();
}

void CWinPSKView::OnEditUndo() 
{
CWinPSKDoc* pDoc = GetDocument();
CWnd* pWnd = GetFocus();
	if( pWnd == pDoc->m_pTheirCallEdit)
		pDoc->m_pTheirCallEdit->Undo();
	else
		if( pWnd == pDoc->m_pXmitEdit )
			pDoc->m_pXmitEdit->Undo();
}
///////////////////  Indicate what clipboard operations are OK
void CWinPSKView::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
CWinPSKDoc* pDoc = GetDocument();
CWnd* pWnd = GetFocus();
LONG s,e;
	if( pWnd == pDoc->m_pTheirCallEdit)
	{
		pDoc->m_pTheirCallEdit->GetSel(s,e);
		pCmdUI->Enable( e > s );
	}
	else
		if( pWnd == pDoc->m_pRcvEdit )
			pCmdUI->Enable( pDoc->m_pRcvEdit->OKCopy() );
		else
			pCmdUI->Enable( FALSE );
}

void CWinPSKView::OnUpdateEditCut(CCmdUI* pCmdUI) 
{
CWinPSKDoc* pDoc = GetDocument();
CWnd* pWnd = GetFocus();
LONG s,e;
	if( pWnd == pDoc->m_pTheirCallEdit)
	{
		pDoc->m_pTheirCallEdit->GetSel(s,e);
		pCmdUI->Enable( e > s );
	}
	else
		if( pWnd == pDoc->m_pXmitEdit )
			pCmdUI->Enable( pDoc->m_pXmitEdit->OKCutClip() );
		else
			pCmdUI->Enable( FALSE );
}

void CWinPSKView::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
CWinPSKDoc* pDoc = GetDocument();
CWnd* pWnd = GetFocus();
	if( pWnd != pDoc->m_pRcvEdit)
		pCmdUI->Enable( ::IsClipboardFormatAvailable(CF_TEXT) );
	else
		pCmdUI->Enable( FALSE );
}

void CWinPSKView::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
CWinPSKDoc* pDoc = GetDocument();
CWnd* pWnd = GetFocus();
	if( pWnd == pDoc->m_pTheirCallEdit)
		pCmdUI->Enable( pDoc->m_pTheirCallEdit->CanUndo() );
	else
		if( pWnd == pDoc->m_pXmitEdit )
			pCmdUI->Enable( pDoc->m_pXmitEdit->CanUndo() );	
		else
			pCmdUI->Enable( FALSE );
}


void CWinPSKView::OnUpdateEditClear(CCmdUI* pCmdUI) 
{
CWinPSKDoc* pDoc = GetDocument();
CWnd* pWnd = GetFocus();
LONG s,e;
	if( pWnd == pDoc->m_pTheirCallEdit)
	{
		pDoc->m_pTheirCallEdit->GetSel(s,e);
		pCmdUI->Enable( e > s );
	}
	else
		if( pWnd == pDoc->m_pXmitEdit )
			pCmdUI->Enable( pDoc->m_pXmitEdit->OKClearSel() );
		else
			pCmdUI->Enable( FALSE );

}

////////////////////////////////////////////////////////////////////
////////////////   Macro Key Functionality    //////////////////
////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Called when Right mouse Button is clicked on a macro button.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	switch( pWnd->GetDlgCtrlID() )
	{
		case IDC_M1BUTTON:
			MacroDlg(0);
			break;
		case IDC_M2BUTTON:
			MacroDlg(1);
			break;
		case IDC_M3BUTTON:
			MacroDlg(2);
			break;
		case IDC_M4BUTTON:
			MacroDlg(3);
			break;
		case IDC_M5BUTTON:
			MacroDlg(4);
			break;
		case IDC_M6BUTTON:
			MacroDlg(5);
			break;
		default:
			break;
	}
}


//////////////////////////////////////////////////////////////////////
// Called to bring up a macro setup dialog.
//////////////////////////////////////////////////////////////////////
void CWinPSKView::MacroDlg(INT id)
{
CWinPSKDoc* pDoc = GetDocument();
CMacroDlg dlg;
	dlg.m_sMacroTitle = pDoc->m_pSettings->m_saMacroTitle[id];
	dlg.m_sData = pDoc->m_pSettings->m_saMacroData[id];
	if (dlg.DoModal() == IDOK)
	{
		pDoc->m_pSettings->m_saMacroData.SetAt(id,dlg.m_sData);
		pDoc->m_pSettings->m_saMacroTitle.SetAt(id,dlg.m_sMacroTitle);
		if( id == 0 )
			m_MTitleCtrl[id].SetWindowText( _T("(F11) ") + dlg.m_sMacroTitle);
		else if( id == 1 )
			m_MTitleCtrl[id].SetWindowText( _T("(F12) ") + dlg.m_sMacroTitle);
		else
			m_MTitleCtrl[id].SetWindowText( dlg.m_sMacroTitle);
		UpdateData(FALSE);
	}
}

///////////////////////////////////////////////////////////////////////
// Routines called when macro buttons are left clicked to execute
///////////////////////////////////////////////////////////////////////
void CWinPSKView::OnM1button() 
{
CWinPSKDoc* pDoc = GetDocument();
	pDoc->m_pXmitEdit->InsertCString( pDoc->m_pSettings->m_saMacroData[0] );
}

void CWinPSKView::OnM2button() 
{
CWinPSKDoc* pDoc = GetDocument();
	pDoc->m_pXmitEdit->InsertCString( pDoc->m_pSettings->m_saMacroData[1] );
}

void CWinPSKView::OnM3button() 
{
CWinPSKDoc* pDoc = GetDocument();
	pDoc->m_pXmitEdit->InsertCString( pDoc->m_pSettings->m_saMacroData[2] );
}

void CWinPSKView::OnM4button() 
{
CWinPSKDoc* pDoc = GetDocument();
	pDoc->m_pXmitEdit->InsertCString( pDoc->m_pSettings->m_saMacroData[3] );
}

void CWinPSKView::OnM5button() 
{
CWinPSKDoc* pDoc = GetDocument();
	pDoc->m_pXmitEdit->InsertCString( pDoc->m_pSettings->m_saMacroData[4] );
}



void CWinPSKView::OnM6button() 
{
CWinPSKDoc* pDoc = GetDocument();
	pDoc->m_pXmitEdit->InsertCString( pDoc->m_pSettings->m_saMacroData[5] );
	
}

