// WinPSKView.h : interface of the CWinPSKView class
//
//////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_WINPSKVIEW_H__EFF3B52C_3631_11D3_B48C_E03851C10000__INCLUDED_)
#define AFX_WINPSKVIEW_H__EFF3B52C_3631_11D3_B48C_E03851C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PlotData.h"
#include "IOCntrl.h"	// Added by ClassView
#include "squelchctrl.h"

#define MIN_FREQ 100
#define MAX_FREQ 2200


class CWinPSKView : public CFormView
{
protected: // create from serialization only
	CWinPSKView();
	DECLARE_DYNCREATE(CWinPSKView)

public:
	//{{AFX_DATA(CWinPSKView)
	enum { IDD = IDD_WINPSK_FORM };
	CButton	m_AFCCtrl;
	CButton	m_QPSKCtrl;
	CButton	m_TXTuneCtrl;
	CButton	m_PauseCtrl;
	CButton	m_TRCntrl;
	CStatic	m_XMinCntrl;
	CStatic	m_XMaxCntrl;
	CTabCtrl	m_DispTabCtrl;
	UINT	m_RxFreq;
	CString	m_XMaxCStr;
	CString	m_XMinCStr;
	CString	m_ZoomTxt;
	BOOL	m_fSlowAve;
	BOOL	m_UseAFC;
	BOOL	m_TXNet;
	UINT	m_TxFreq;
	int		m_PSKMode;
	//}}AFX_DATA
	CButton	m_MTitleCtrl[NUM_MACROS];	//button ctrl array to access macro title strings
// Attributes
public:
	CWinPSKDoc* GetDocument();
	void ChngFreq( INT delta);
	void ToggleTR();
// Operations
public:
	CIOCntrl* m_pIOCntrl;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinPSKView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Implementation
public:
	void ProcessFKeys(WPARAM wParam);
	virtual ~CWinPSKView();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	CSquelchCtrl* m_pSquelchCtrl;
	//{{AFX_MSG(CWinPSKView)
	afx_msg void OnDestroy();
	afx_msg void OnSelchangeDisplaytab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnDeltaposZoom(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposRxFreqspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnSlowave();
	afx_msg void OnAfc();
	afx_msg void OnTrbutton();
	afx_msg void OnBpsk();
	afx_msg void OnQpsk();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnTxpause();
	afx_msg void OnTxtune();
	afx_msg void OnNet();
	afx_msg void OnEditPaste();
	afx_msg void OnEditCopy();
	afx_msg void OnEditCut();
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnEditClear();
	afx_msg void OnUpdateEditClear(CCmdUI* pCmdUI);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnKillfocusRxfreq();
	afx_msg void OnSetfocusRxfreq();
	afx_msg void OnKillfocusTxfreq();
	afx_msg void OnDeltaposTxfreqspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCwid();
	afx_msg void OnSetfocusTxfreq();
	afx_msg void OnM1button();
	afx_msg void OnM2button();
	afx_msg void OnM3button();
	afx_msg void OnM4button();
	afx_msg void OnM5button();
	afx_msg void OnM6button();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL m_ZoomOK;
	BOOL m_fRxFreqEditing;
	BOOL m_fTxFreqEditing;
	BOOL m_NeedUpdate;
	INT m_PlotWidth;
	UINT m_TimerID;
	CPlotData* m_pCPlotData;
	HCURSOR m_hOrigCursor;
	HCURSOR m_hCross;

	void UpdateStatus();
	void ChngZoom(INT delta);
	void UpdatePlotInfo(INT src);
	void SetAFCNarrow(BOOL narrow);
	void MacroDlg( INT id);
	INT IndexToFreq(INT index);
	INT IndexToTime(INT index);
	INT FreqToIndex(INT Freq);
};

#ifndef _DEBUG  // debug version in WinPSKView.cpp
inline CWinPSKDoc* CWinPSKView::GetDocument()
   { return (CWinPSKDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WINPSKVIEW_H__EFF3B52C_3631_11D3_B48C_E03851C10000__INCLUDED_)
